//for complete
float acquisitionInitialDiameterB(){ //acquisition and check of the initial diameter
  mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
  mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
  mylcd.Print_String("Press '#' to confirm the value", 0, 54);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
  mylcd.Print_String("re-insert a new one", 0, 90);
  delay(300);

  startDiameter = 0;
  checkDiameter = 0;
  diameter1 = "";

  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted 
        diameter1 += inCharKey;
        mylcd.Print_String("Initial diameter [mm]: " + diameter1, 0, 126);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.' 
        diameter1 += '.';
        mylcd.Print_String("Initial diameter [mm]: " + diameter1, 0, 126);
        delay(50);
      }else if(inCharKey == 'C'){ //clear the variable containing the parameter
        diameter1 = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical complete cycle", 0, 0);
        mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
        mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
        mylcd.Print_String("Press '#' to confirm the value", 0, 54);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
        mylcd.Print_String("re-insert a new one", 0, 90);
        mylcd.Print_String("Initial diameter [mm]: ", 0 , 126);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted 
        startDiameter = diameter1.toFloat();
        if(startDiameter > 0 && startDiameter <= maximumDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Initial diameter: ACCEPTED", 0, 144);
          delay(1000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Initial diameter not valid", 0, 144);
          mylcd.Print_String("Insert a new value", 0, 162);
          delay(1000);
          
          startDiameter = 0;
          diameter1 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical complete cycle", 0, 0);
          mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
          mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
          mylcd.Print_String("Press '#' to confirm the value", 0, 54);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
          mylcd.Print_String("re-insert a new one", 0, 90);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  Serial.println(startDiameter);
  return startDiameter;
}

//for multidiameter
float acquisitionInitialDiameterC(){ //acquisition and check of the initial diameter
  mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
  mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
  mylcd.Print_String("Press '#' to confirm the value", 0, 54);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
  mylcd.Print_String("re-insert a new one", 0, 90);
  delay(300);

  startDiameter = 0;
  checkDiameter = 0;
  diameter1 = "";

  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted 
        diameter1 += inCharKey;
        mylcd.Print_String("Initial diameter [mm]: " + diameter1, 0, 126);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.' 
        diameter1 += '.';
        mylcd.Print_String("Initial diameter [mm]: " + diameter1, 0, 126);
        delay(50);
      }else if(inCharKey == 'C'){ //clear the variable containing the parameter
        diameter1 = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
        mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
        mylcd.Print_String("Press '#' to confirm the value", 0, 54);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
        mylcd.Print_String("re-insert a new one", 0, 90);
        mylcd.Print_String("Initial diameter [mm]: ", 0 , 126);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted 
        startDiameter = diameter1.toFloat();
        if(startDiameter > 0 && startDiameter <= maximumDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Initial diameter: ACCEPTED", 0, 144);
          delay(1000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Initial diameter not valid", 0, 144);
          mylcd.Print_String("Insert a new value", 0, 162);
          delay(1000);

          startDiameter = 0;
          diameter1 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
          mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
          mylcd.Print_String("Press '#' to confirm the value", 0, 54);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
          mylcd.Print_String("re-insert a new one", 0, 90);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  Serial.println(startDiameter);
  return startDiameter;
}

//for conical
float acquisitionInitialDiameterD(){ //acquisition and check of the initial diameter
  mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
  mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
  mylcd.Print_String("Press '#' to confirm the value", 0, 54);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
  mylcd.Print_String("re-insert a new one", 0, 90);
  delay(300);

  startDiameter = 0;
  checkDiameter = 0;
  diameter1 = "";

  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted 
        diameter1 += inCharKey;
        mylcd.Print_String("Initial diameter [mm]: " + diameter1, 0, 126);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.' 
        diameter1 += '.';
        mylcd.Print_String("Initial diameter [mm]: " + diameter1, 0, 126);
        delay(50);
      }else if(inCharKey == 'C'){ //clear the variable containing the parameter
        diameter1 = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Conical cycle", 0, 0);
        mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
        mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
        mylcd.Print_String("Press '#' to confirm the value", 0, 54);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
        mylcd.Print_String("re-insert a new one", 0, 90);
        mylcd.Print_String("Initial diameter [mm]: ", 0 , 126);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted 
        startDiameter = diameter1.toFloat();
        if(startDiameter > 0 && startDiameter <= maximumDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Initial diameter: ACCEPTED", 0, 144);
          delay(1000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Initial diameter not valid", 0, 144);
          mylcd.Print_String("Insert a new value", 0, 162);
          delay(1000);

          startDiameter = 0;
          diameter1 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Conical cycle", 0, 0);
          mylcd.Print_String("Insert the initial diameter of the piece", 0, 18);
          mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
          mylcd.Print_String("Press '#' to confirm the value", 0, 54);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
          mylcd.Print_String("re-insert a new one", 0, 90);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  Serial.println(startDiameter);
  return startDiameter;
}

//for complete
float acquisitionFinalDiameterB(float initialDiameter){ //acquisition of the final diameter
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical complete cycle", 0, 0);
  mylcd.Print_String("Insert the final diameter of the piece", 0, 18);
  mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
  mylcd.Print_String("Press '#' to confirm the value", 0, 54);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
  mylcd.Print_String("re-insert a new one", 0, 90);
  delay(300);

  checkDiameter = 0;
  finalDiameter = 0;
  diameter2 = "";

  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        diameter2 += inCharKey;
        mylcd.Print_String("Final diameter [mm]: " + diameter2, 0, 126);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        diameter2 += '.';
        mylcd.Print_String("Final diameter [mm]: " + diameter2, 0, 126);
        delay(50);
      }else if(inCharKey == 'C'){
        diameter2 = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical roughing cycle", 0, 0);
        mylcd.Print_String("Insert the final diameter of the piece", 0, 18);
        mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
        mylcd.Print_String("Press '#' to confirm the value", 0, 54);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
        mylcd.Print_String("re-insert a new one", 0, 90);
        mylcd.Print_String("Final diameter [mm]: ", 0, 126);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        finalDiameter = diameter2.toFloat();
        if(finalDiameter > 0 && finalDiameter <= maximumDiameter && finalDiameter <= initialDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Final diameter: ACCEPTED", 0, 144);
          delay(2000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Final diameter not valid", 0, 144);
          mylcd.Print_String("Insert a new value", 0, 162);
          delay(1000);

          finalDiameter = 0;
          diameter2 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical complete cycle", 0, 0);
          mylcd.Print_String("Insert the final diameter of the piece", 0, 18);
          mylcd.Print_String("with the keypad between 0 mm and 30 mm", 0, 36);
          mylcd.Print_String("Press '#' to confirm the value", 0, 54);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
          mylcd.Print_String("re-insert a new one", 0, 90);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  Serial.println(finalDiameter);
  return finalDiameter;
}

//for multidimensional
float acquisitionSmallerDiameter(float initialDiameter){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  mylcd.Print_String("Insert the final diameter of the smaller", 0, 18);
  mylcd.Print_String("part of the piece with the keypad", 0, 36);
  mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);

  checkDiameter = 0;
  finalDiameter = 0;
  diameter2 = "";
  
  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        diameter2 += inCharKey;
        mylcd.Print_String("Smaller final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        diameter2 += '.';
        mylcd.Print_String("Smaller final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        diameter2 = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the  final diameter of the smaller", 0, 18);
        mylcd.Print_String("part of the piece with the keypad", 0, 36);
        mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Smaller final diameter [mm]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        finalDiameter = diameter2.toFloat();
        Serial.println(finalDiameter);
        if(finalDiameter > 0 && finalDiameter <= maximumDiameter && finalDiameter < initialDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Final diameter: ACCEPTED", 0, 162);
          delay(2000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Final diameter not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          finalDiameter = 0;
          diameter2 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the  final diameter of the smaller", 0, 18);
          mylcd.Print_String("part of the piece with the keypad", 0, 36);
          mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  return finalDiameter;
}

//for multidimensional
float acquisitionGreaterDiameter(float initialDiameter){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  mylcd.Print_String("Insert the final diameter of the greater", 0, 18);
  mylcd.Print_String("part of the piece with the keypad", 0, 36);
  mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);

  checkDiameter = 0;
  finalDiameter = 0;
  diameter2 = "";
  
  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        diameter2 += inCharKey;
        mylcd.Print_String("Greater final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        diameter2 += '.';
        mylcd.Print_String("Greater final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        diameter2 = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the  final diameter of the greater", 0, 18);
        mylcd.Print_String("part of the piece with the keypad", 0, 36);
        mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Greater final diameter [mm]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        finalDiameter = diameter2.toFloat();
        Serial.println(finalDiameter);
        if(finalDiameter > 0 && finalDiameter <= maximumDiameter && finalDiameter < initialDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Final diameter: ACCEPTED", 0, 162);
          delay(2000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Final diameter not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          finalDiameter = 0;
          diameter2 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the  final diameter of the greater", 0, 18);
          mylcd.Print_String("part of the piece with the keypad", 0, 36);
          mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  return finalDiameter;
}

//for complete
float checkFeedXcomplete(float initialDiameter, float workDiameter){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical complete cycle", 0, 0);
  mylcd.Print_String("Initial diameter: " + String(initialDiameter) + " mm", 0, 18);
  mylcd.Print_String("Final diameter: " + String(workDiameter) + " mm", 0, 36);
  feedXint = (initialDiameter - workDiameter)/2;
  feedXint = feedXint - feedXfinish;
  if(feedXint <= maxFeedX){
    numberCycles = 1;
    mylcd.Print_String(String(numberCycles) + " cycle needed", 0, 72);
    delay(2000);
  }else{
    numberCycles = (int)(feedXint/maxFeedX);
    ver = feedXint - numberCycles*maxFeedX;
    if(ver != 0){
      numberCycles++;
    }
    mylcd.Print_String(String(numberCycles) + " cycles needed", 0, 72);
    delay(2000);
  }
  return feedXint;
}

//for multidiameter
float checkFeedXC(float initialDiameter, float workDiameter){
  feedXint = (initialDiameter - workDiameter)/2;
  if(feedXint <= maxFeedX){
    numberCycles = 1;
    mylcd.Print_String(String(numberCycles) + " cycle needed", 0, 72);
    delay(2000);
  }else{
    numberCycles = (int)(feedXint/maxFeedX);
    ver = feedXint - numberCycles*maxFeedX;
    if(ver != 0){
      numberCycles++;
    }
    mylcd.Print_String(String(numberCycles) + " cycles needed", 0, 72);
    delay(2000);
  }
  Serial.println(feedXint);
  Serial.println(numberCycles);
  return feedXint;
}

//ONLY for the conical turning
float acquisitionFinalDiameterConicalBegin(float initialDiameter){ //acquisition of the final diameter (for the conical turning it is the final diameter at the beginning of the piece)
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Conical cycle", 0, 0);
  mylcd.Print_String("Insert the final diameter of the smaller", 0, 18);
  mylcd.Print_String("part of the cone with the keypad", 0, 36);
  mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);

  checkDiameter = 0;
  finalDiameter = 0;
  diameter2 = "";

  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //an admissible number has been inserted
        diameter2 += inCharKey;
        mylcd.Print_String("Smaller final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        diameter2 += '.';
        mylcd.Print_String("Smaller final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){ //delete the digits that have been inserted
        diameter2 = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Conical cycle", 0, 0);
        mylcd.Print_String("Insert the final diameter of the smaller", 0, 18);
        mylcd.Print_String("part of the cone with the keypad", 0, 36);
        mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Smaller final diameter [mm]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        finalDiameter = diameter2.toFloat();
        Serial.println(finalDiameter);
        if(finalDiameter > 0 && finalDiameter <= maximumDiameter && finalDiameter <= initialDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Smaller final diameter: ACCEPTED", 0, 162);
          delay(1000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Final diameter not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          finalDiameter = 0;
          diameter2 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Conical cycle", 0, 0);
          mylcd.Print_String("Insert the final diameter of the smaller", 0, 18);
          mylcd.Print_String("part of the cone with the keypad", 0, 36);
          mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  return finalDiameter;
}

//ONLY for the conical turning
float acquisitionFinalDiameterConicalEnd(float initialDiameter){ //acquisition of the final diameter (for the conical turning it is the final diameter at the beginning of the piece)
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Conical cycle", 0, 0);
  mylcd.Print_String("Insert the final diameter of the greater", 0, 18);
  mylcd.Print_String("part of the cone with the keypad", 0, 36);
  mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);
  
  checkDiameter = 0;
  finalDiameter = 0;
  diameter2 = "";

  do{ //acquisition of the value from the keyboard
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //an admissible number has been inserted
        diameter2 += inCharKey;
        mylcd.Print_String("Greater final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        diameter2 += '.';
        mylcd.Print_String("Greater final diameter [mm]: " + diameter2, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){ //delete the digits that have been inserted
        diameter2 = "";
        
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Conical cycle", 0, 0);
        mylcd.Print_String("Insert the final diameter of the greater", 0, 18);
        mylcd.Print_String("part of the cone with the keypad", 0, 36);
        mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Greater final diameter [mm]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        finalDiameter = diameter2.toFloat();
        Serial.println(finalDiameter);
        if(finalDiameter > 0 && finalDiameter <= maximumDiameter && finalDiameter <= initialDiameter){ //check of the correctness of the diameter
          mylcd.Print_String("Greater final diameter: ACCEPTED", 0, 162);
          delay(1000);
          checkDiameter = 1;
        }else{
          mylcd.Print_String("Final diameter not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);
          
          finalDiameter = 0;
          diameter2 = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Conical cycle", 0, 0);
          mylcd.Print_String("Insert the final diameter of the greater", 0, 18);
          mylcd.Print_String("part of the cone with the keypad", 0, 36);
          mylcd.Print_String("between 0 mm and 30 mm", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkDiameter == 0);
  return finalDiameter;
}

//for conical
void checkFeedXconical(){
  checkConicity = 0;
  do{
    feedXbegin = (startDiameter - finalDiameterBegin)/2;
    feedXbegin = feedXbegin - feedXfinish;
    NmaxBegin = (int) feedXbegin/maxFeedX; //number of cycles where the maximum depth of material is removed
    residualFeedXbegin = feedXbegin - NmaxBegin*maxFeedX;
    Serial.print(feedXbegin);
    Serial.print("\t");
    Serial.print(NmaxBegin);
    Serial.print("\t");
    Serial.println(residualFeedXbegin);

    feedXend = (startDiameter - finalDiameterEnd)/2;
    feedXend = feedXend - feedXfinish;
    NmaxEnd = (int) feedXend/maxFeedX;
    residualFeedXend = feedXend - NmaxEnd*maxFeedX;
    Serial.print(feedXend);
    Serial.print("\t");
    Serial.print(NmaxEnd);
    Serial.print("\t");
    Serial.println(residualFeedXend);
    
    //cylindrical turning
    if(finalDiameterBegin < finalDiameterEnd){
      conicity = 1; //variable useful later to decide the direction of motion of the stepper motor: 1 X motor moves forward
      feedXcyclindrical = NmaxEnd*maxFeedX;
      numberCyclesCyl = NmaxEnd; //performed inside the cylindrical part
      deltaX = (finalDiameterEnd/2) - (finalDiameterBegin/2);
      deltaZ = workingLength;
      feedXconicalBegin = feedXbegin - feedXcyclindrical;
      feedXconicalEnd = residualFeedXend;
      NcyclesConicalMax = NmaxBegin - NmaxEnd; //to perform inside the conical part
      checkConicity = 1;
    }
  }while(checkConicity == 0);

  Serial.print(conicity);
  Serial.print("\t");
  Serial.print(feedXcyclindrical);
  Serial.print("\t");
  Serial.print(numberCyclesCyl);
  Serial.print("\t");
  Serial.print(deltaX);
  Serial.print("\t");
  Serial.print(deltaZ);
  Serial.print("\t");
  Serial.print(feedXconicalBegin);
  Serial.print("\t");
  Serial.print(feedXconicalEnd);
  Serial.print("\t");
  Serial.println(NcyclesConicalMax);
}