int completeProcess(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical complete cycle", 0, 0);
  
  lcd.clear();  lcd.print("Complete cycle");
  delay(1000);

  sendEnableStart();
  enb_rot = 0;

  startDiameter = acquisitionInitialDiameterB();
  if(ok == 2){
    return;
  }
  delay(1000);
  finalDiameter = acquisitionFinalDiameterB(startDiameter);
  if(ok == 2){
    return;
  }
  delay(1000);
  feedXrough = checkFeedXcomplete(startDiameter,finalDiameter);
  delay(1000);
  cuttingSpeed = selectCuttingSpeedB();
  if(ok == 2){
    return;
  }
  delay(1000);
  spindleSpeed = suggestSpindleSpeedB(finalDiameter, cuttingSpeed);
  if(ok == 2){
    return;
  }
  delay(1000);
  feedZrough = feedRateZroughB(spindleSpeed); //with the feed rate along axis x, compute the rotational speed of the screw, speed to be inserted in the following functions
  if(ok == 2){
    return;
  }
  delay(1000);
  workingLength = acquisitionWorkingLengthB();
  if(ok == 2){
    return;
  }
  delay(1000);
  
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical complete cycle", 0, 0);
  delay(300);
  sendSpindleSpeed(); //send to the other Arduino the target speed through the serial communication
  if(ok == 2){
    return;
  }
  
  //check the position of the security window
  mylcd.Print_String("Close the window safely", 0, 72);
  lcd.clear();  lcd.print("Close the window");  lcd.setCursor(0,1);  lcd.print("safely");
  do{
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    delay(200);
  }while(startState == HIGH && secCheckState != HIGH);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }

  //enabling of the process and start of the rotation
  okEnable = 0;
  mylcd.Print_String("Press # to enable", 0, 108);
  mylcd.Print_String("the beginning of the process", 0, 126);
  lcd.clear();  lcd.print("Press # enabling");   lcd.setCursor(0,1);  lcd.print("the process");
  do{
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    delay(100);

    varEnable = '0';
    varEnable = customKeypad.getKey(); //acquisition of the command from the keypad
    if(varEnable && varEnable == '#'){
      sendEnableRotation();
      delay(1000);
      okEnable = 1;
    }
  }while(okEnable == 0 && startState == HIGH && secCheckState == HIGH);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }
  delay(1000);

  realSpindleSpeed = 0;
  do{
    realSpindleSpeed = receiveSpindleSpeed();
  }while(startState == HIGH && secCheckState == HIGH && realSpindleSpeed == 0);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }
  delay(1000);

  positioningProcessB(workingLength, feedXrough);
  if(ok == 2){
    return;
  }
  delay(1000);

  //roughing part
  if(numberCycles == 1){
    comebackVarZ = workingProcess1Cycle(workingLength, rotationalSpeedScrew); //only one cycle must be perfomed
  }else if(numberCycles > 1){
    comebackVarZ = workingProcessMoreCycles(workingLength, rotationalSpeedScrew, feedXrough); //more than 1 cycles must be perfomed
  }
  if(ok == 2){
    return;
  }
  delay(1000);
  feedZfinish = 0.4;
  rotationalSpeedScrew = (int) (feedZfinish*spindleSpeed*pitch);
  delay(1000);

  comebackVarZ = finishProcess(workingLength, rotationalSpeedScrew, feedXrough);
  if(ok == 2){
    return;
  }
  delay(1000);
  //send to the other Arduino the command to stop the rotation
  sendStop();
  delay(1000);

  backHome(comebackVarZ,comebackVarX);
  delay(1000);

  //check the position of the security window
  mylcd.Print_String("Open the window safely", 0, 126);
  lcd.clear();  lcd.print("Open the window");  lcd.setCursor(0,1);  lcd.print("safely");
  do{
    secCheckState = digitalRead(secCheckPin);
    delay(200);
  }while(secCheckState != LOW);
    
  mylcd.Print_String("Ready for a new process", 0, 162);
  lcd.clear();  lcd.print("Ready for a new");  lcd.setCursor(0,1);  lcd.print("workcycle");
  delay(2000);
  
  ok = 1;
  return ok;
}