int conical(){ //perform the conical turning with an included finishing process as well
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Conical turning cycle", 0, 0);
  delay(1000);

  sendEnableStart();
  enb_rot = 0;

  startDiameter = acquisitionInitialDiameterD();
  if(ok == 2){
    return;
  }
  delay(1000);

  do{
    finalDiameterBegin = acquisitionFinalDiameterConicalBegin(startDiameter); //final diameter at the begin of the piece (with respect to the direction of approaching of the tool)
    if(ok == 2){
      return;
    }
    delay(1000);

    finalDiameterEnd = acquisitionFinalDiameterConicalEnd(startDiameter); //final diameter at the end of the piece (with respect to the direction of approaching of the tool)
    if(ok == 2){
      return;
    }
    delay(1000);
    if(finalDiameterBegin >= finalDiameterEnd){
      mylcd.Fill_Screen(BLUE);
      mylcd.Print_String("Conical turning cycle", 0, 0);
      mylcd.Print_String("ERROR!", 0, 18);
      mylcd.Print_String("Insert new values", 0, 36);
      mylcd.Print_String("for the final diameters", 0, 54);
    }
  }while(finalDiameterBegin >= finalDiameterEnd);

  cuttingSpeed = selectCuttingSpeedD();
  if(ok == 2){
    return;
  }
  delay(1000);
  avgFinalDiameter = (finalDiameterBegin + finalDiameterEnd)/2;
  spindleSpeed = suggestSpindleSpeedD(avgFinalDiameter,cuttingSpeed);
  if(ok == 2){
    return;
  }
  delay(1000);
  feedZrough = feedRateZroughD(spindleSpeed);
  if(ok == 2){
    return;
  }
  delay(1000);
  workingLength = acquisitionWorkingLengthD();
  if(ok == 2){
    return;
  }
  delay(1000);

  checkFeedXconical();
  
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Conical cycle", 0, 0);
  delay(300);
  sendSpindleSpeed(); //send to the other Arduino the target speed through the serial communication
  if(ok == 2){
    return;
  }
  
  //check the position of the security window
  mylcd.Print_String("Close the window safely", 0, 72);
  lcd.clear();  lcd.print("Close the window");  lcd.setCursor(0,1);  lcd.print("safely");
  do{
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    delay(200);
  }while(startState == HIGH && secCheckState != HIGH);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }

  //enabling of the process and start of the rotation
  okEnable = 0;
  mylcd.Print_String("Press # to enable", 0, 108);
  mylcd.Print_String("the beginning of the process", 0, 126);
  lcd.clear();  lcd.print("Press # enabling");  lcd.setCursor(0,1);  lcd.print("the process");
  delay(1000);
  do{
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    delay(100);

    varEnable = '0';
    varEnable = customKeypad.getKey(); //acquisition of the command from the keypad
    if(varEnable && varEnable == '#'){
      sendEnableRotation();
      delay(1000);
      okEnable = 1;
    }
  }while(okEnable == 0 && startState == HIGH && secCheckState == HIGH);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }
  delay(1000);

  realSpindleSpeed = 0;
  do{
    realSpindleSpeed = receiveSpindleSpeed();
  }while(startState == HIGH && secCheckState == HIGH && realSpindleSpeed == 0);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }
  delay(1000);

  positioningProcessD(workingLength,feedXcyclindrical);
  if(ok == 2){
    return;
  }
  delay(1000);

  if(numberCyclesCyl == 1){
    comebackVarZ = workingProcess1Cycle(workingLength,rotationalSpeedScrew); //only one cycle must be perfomed
  }else if(numberCyclesCyl > 1){
    comebackVarZ = workingProcessMoreCyclesCyl(workingLength,rotationalSpeedScrew); //more than 1 cycles must be perfomed
  }
  if(ok == 2){
    return;
  }
  delay(1000);
  //conclusion of the initial cyclindrical turning and the tool remains in the positioning place

  //conical turning
  //firstly complete the removal of the material according to the maximum feed X (begin or end)
  comebackVarZ = conicalTurning(rotationalSpeedScrew);
  if(ok == 2){
    return;
  }
  delay(1000);

  //finishing process
  feedXfinish = 0.01; //10 micrometer
  feedZfinish = 0.4;
  rotationalSpeedScrew = (int) (feedZfinish*spindleSpeed*pitch);
  delay(1000);

  comebackVarZ = finishProcessConical(rotationalSpeedScrew);
  if(ok == 2){
    return;
  }
  delay(1000);
  
  //send to the other Arduino the command to stop the rotation
  sendStop();
  delay(1000);

  backHome(comebackVarZ,comebackVarX);
  delay(1000);

  //check the position of the security window
  mylcd.Print_String("Open the window safely", 0, 126);
  lcd.clear();  lcd.print("Open the window");  lcd.setCursor(0,1);  lcd.print("safely");
  do{
    secCheckState = digitalRead(secCheckPin);
    delay(200);
  }while(secCheckState != LOW);

  mylcd.Print_String("Ready for a new process", 0, 162);
  lcd.clear();  lcd.print("Ready for a new");  lcd.setCursor(0,1);  lcd.print("workcycle");
  delay(2000);

  ok = 1;
  return ok;
}