//for complete
int selectCuttingSpeedB(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical complete cycle", 0, 0);
  mylcd.Print_String("Insert the cutting speed of the", 0, 18);
  mylcd.Print_String("workcycle with the keypad", 0, 36);
  mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);
  delay(300);

  cuttingSpeed = 0;
  checkSpeed = 0;
  speed = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){
        speed += inCharKey;
        mylcd.Print_String("Cutting speed [m/min]: " + speed, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        speed = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical complete cycle", 0, 0);
        mylcd.Print_String("Insert the cutting speed of the", 0, 18);
        mylcd.Print_String("workcycle with the keypad", 0, 36);
        mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Cutting speed [m/min]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        cuttingSpeed = speed.toInt();
        if(cuttingSpeed > 0 && cuttingSpeed <= maximumCuttingSpeed){
          mylcd.Print_String("Cutting speed: ACCEPTED", 0, 162);
          delay(1000);
          checkSpeed = 1;
        }else{
          mylcd.Print_String("Cutting speed not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          cuttingSpeed = 0;
          speed = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical complete cycle", 0, 0);
          mylcd.Print_String("Insert the cutting speed of the", 0, 18);
          mylcd.Print_String("workcycle with the keypad", 0, 36);
          mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkSpeed == 0);
  Serial.println(cuttingSpeed);
  return cuttingSpeed;
}

//for multidiameter
int selectCuttingSpeedC(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  mylcd.Print_String("Insert the cutting speed of the", 0, 18);
  mylcd.Print_String("workcycle with the keypad", 0, 36);
  mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);  
  delay(300);

  cuttingSpeed = 0;
  checkSpeed = 0;
  speed = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){
        speed += inCharKey;
        mylcd.Print_String("Cutting speed [m/min]: " + speed, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        speed = "";
        lcd.clear();        lcd.print("Cutting speed");        lcd.setCursor(0,1);        lcd.print("0.00 mm");
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the cutting speed of the", 0, 18);
        mylcd.Print_String("workcycle with the keypad between 0 m/min and 40", 0, 36);
        mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Cutting speed [m/min]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        cuttingSpeed = speed.toInt();
        if(cuttingSpeed > 0 && cuttingSpeed <= maximumCuttingSpeed){
          lcd.clear();          lcd.print("Cutting speed:");          lcd.setCursor(0,1);          lcd.print(String(cuttingSpeed) + " m/min");
          mylcd.Print_String("Cutting speed: ACCEPTED", 0, 162);
          delay(2000);
          checkSpeed = 1;
        }else{
          mylcd.Print_String("Cutting speed not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          cuttingSpeed = 0;
          speed = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the cutting speed of the", 0, 18);
          mylcd.Print_String("workcycle with the keypad between 0 m/min and 40", 0, 36);
          mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkSpeed == 0);
  Serial.println(cuttingSpeed);
  return cuttingSpeed;
}

//for conical
int selectCuttingSpeedD(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical conical cycle", 0, 0);
  mylcd.Print_String("Insert the cutting speed of the", 0, 18);
  mylcd.Print_String("workcycle with the keypad", 0, 36);
  mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);
  delay(300);

  cuttingSpeed = 0;
  checkSpeed = 0;
  speed = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){
        speed += inCharKey;
        mylcd.Print_String("Cutting speed [m/min]: " + speed, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        speed = "";
        lcd.clear();        lcd.print("Cutting speed");        lcd.setCursor(0,1);        lcd.print("0.00 mm");
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical conical cycle", 0, 0);
        mylcd.Print_String("Insert the cutting speed of the", 0, 18);
        mylcd.Print_String("workcycle with the keypad between 0 m/min and 40", 0, 36);
        mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Cutting speed [m/min]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        cuttingSpeed = speed.toInt();
        if(cuttingSpeed > 0 && cuttingSpeed <= maximumCuttingSpeed){
          lcd.clear();          lcd.print("Cutting speed:");          lcd.setCursor(0,1);          lcd.print(String(cuttingSpeed) + " m/min");
          mylcd.Print_String("Cutting speed: ACCEPTED", 0, 162);
          delay(2000);
          checkSpeed = 1;
        }else{
          mylcd.Print_String("Cutting speed not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          cuttingSpeed = 0;
          speed = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical conical cycle", 0, 0);
          mylcd.Print_String("Insert the cutting speed of the", 0, 18);
          mylcd.Print_String("workcycle with the keypad between 0 m/min and 40", 0, 36);
          mylcd.Print_String("between 0 m/min and 40 m/min", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkSpeed == 0);
  Serial.println(cuttingSpeed);
  return cuttingSpeed;
}

//for complete
int suggestSpindleSpeedB(float workDiameter, float cutSpeed){ //check the value of the computed speed, it must be included inside an acceptable range
  do{
    checkSpindleSpeed = 0;
    spindleSpeed = (int)1000*cutSpeed/(piGreco*workDiameter);
    targetMin = spindleSpeed - toleranceSpeed*spindleSpeed;
    targetMax = spindleSpeed + toleranceSpeed*spindleSpeed;

    if(spindleSpeed <= maxSpindleSpeed){     
      mylcd.Print_String("Spindle speed: " + String(spindleSpeed) + " rpm", 0, 198);
      delay(1000);
      checkSpindleSpeed = 1;
    }else{
      mylcd.Print_String("The value of spindle speed is too high", 0, 198);
      mylcd.Print_String("Choose a lower value for the cutting speed", 0, 216);
      delay(1000);

      cuttingSpeed = selectCuttingSpeedB();
      cutSpeed = cuttingSpeed;
    }
  }while(checkSpindleSpeed == 0);
  Serial.println(spindleSpeed);
  return spindleSpeed;
}

//for multidiameter
int suggestSpindleSpeedC(float workDiameter, float cutSpeed){ //check the value of the computed speed, it must be included inside an acceptable range
  do{
    checkSpindleSpeed = 0;
    spindleSpeed = (int)1000*cutSpeed/(piGreco*workDiameter);
    targetMin = spindleSpeed - toleranceSpeed*spindleSpeed;
    targetMax = spindleSpeed + toleranceSpeed*spindleSpeed;

    if(spindleSpeed <= maxSpindleSpeed){    
      mylcd.Print_String("Spindle speed: " + String(spindleSpeed) + " rpm", 0, 198);
      delay(1000);
      checkSpindleSpeed = 1;
    }else{
      mylcd.Print_String("The value of spindle speed is too high", 0, 198);
      mylcd.Print_String("Choose a lower value for the cutting speed", 0, 216);
      delay(1000);

      cuttingSpeed = selectCuttingSpeedC();
      cutSpeed = cuttingSpeed;
    }
  }while(checkSpindleSpeed == 0);
  Serial.println(spindleSpeed);
  return spindleSpeed;
}

//for conical
int suggestSpindleSpeedD(float workDiameter, float cutSpeed){ //check the value of the computed speed, it must be included inside an acceptable range
  do{
    checkSpindleSpeed = 0;
    spindleSpeed = (int)1000*cutSpeed/(piGreco*workDiameter);
    targetMin = spindleSpeed - toleranceSpeed*spindleSpeed;
    targetMax = spindleSpeed + toleranceSpeed*spindleSpeed;

    if(spindleSpeed <= maxSpindleSpeed){     
      mylcd.Print_String("Spindle speed: " + String(spindleSpeed) + " rpm", 0, 198);
      delay(1000);
      checkSpindleSpeed = 1;
    }else{
      mylcd.Print_String("The value of spindle speed is too high", 0, 198);
      mylcd.Print_String("Choose a lower value for the cutting speed", 0, 216);
      delay(1000);

      cuttingSpeed = selectCuttingSpeedD();
      cutSpeed = cuttingSpeed;
    }
  }while(checkSpindleSpeed == 0);
  Serial.println(spindleSpeed);
  return spindleSpeed;
}