//for complete
float feedRateZroughB(int rotationalSpeed){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical complete cycle", 0, 0);
  mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
  mylcd.Print_String("with the keypad", 0, 36);
  mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);
  delay(300);

  feedZ1 = 0;
  checkFeedZ = 0;
  movementZ = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        movementZ += inCharKey;
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: " + movementZ, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        movementZ += '.';
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: " + movementZ, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        movementZ = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical complete cycle", 0, 0);
        mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
        mylcd.Print_String("with the keypad", 0, 36);
        mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        feedZ1 = movementZ.toFloat();
        if(feedZ1 > 0 && (feedZ1 >= 0.35 && feedZ1 <=0.65)){
          mylcd.Print_String("Feed rate Z-axis: ACCEPTED", 0, 162);
          delay(1000);
          rotationalSpeedScrew = (int) (feedZ1*rotationalSpeed*pitch);
          checkFeedZ = 1;
        }else{
          mylcd.Print_String("Feed rate Z-axis not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          feedZ1 = 0;
          movementZ = "";                  
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical complete cycle", 0, 0);
          mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
          mylcd.Print_String("with the keypad", 0, 36);
          mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkFeedZ == 0);
  Serial.println(feedZ1);
  Serial.println(rotationalSpeedScrew);
  return feedZ1;
}

//for multidiameter
float feedRateZroughC(int rotationalSpeed){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
  mylcd.Print_String("with the keypad", 0, 36);
  mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);
  delay(300);

  feedZ1 = 0;
  checkFeedZ = 0;
  movementZ = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        movementZ += inCharKey;
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: " + movementZ, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        movementZ += '.';
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: " + movementZ, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        movementZ = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
        mylcd.Print_String("with the keypad", 0, 36);
        mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        feedZ1 = movementZ.toFloat();
        if(feedZ1 > 0 && (feedZ1 >= 0.35 && feedZ1 <=0.65)){
          mylcd.Print_String("Feed rate Z-axis: ACCEPTED", 0, 162);
          delay(2000);
          rotationalSpeedScrew = (int) (feedZ1*rotationalSpeed*pitch);
          checkFeedZ = 1;
        }else{
          mylcd.Print_String("Feed rate Z-axis not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          feedZ1 = 0;
          movementZ = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
          mylcd.Print_String("with the keypad", 0, 36);
          mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkFeedZ == 0);
  Serial.println(feedZ1);
  Serial.println(rotationalSpeedScrew);
  return feedZ1;
}

//for conical
float feedRateZroughD(int rotationalSpeed){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Conical cycle", 0, 0);
  mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
  mylcd.Print_String("with the keypad", 0, 36);
  mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);
  delay(300);

  feedZ1 = 0;
  checkFeedZ = 0;
  movementZ = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        movementZ += inCharKey;
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: " + movementZ, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        movementZ += '.';
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: " + movementZ, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        movementZ = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Conical cycle", 0, 0);
        mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
        mylcd.Print_String("with the keypad", 0, 36);
        mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Feed rate Z-axis [mm/rotation]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        feedZ1 = movementZ.toFloat();
        if(feedZ1 > 0 && (feedZ1 >= 0.35 && feedZ1 <=0.65)){
          mylcd.Print_String("Feed rate Z-axis: ACCEPTED", 0, 162);
          delay(1000);
          rotationalSpeedScrew = (int) (feedZ1*rotationalSpeed*pitch);
          checkFeedZ = 1;
        }else{
          mylcd.Print_String("Feed rate Z-axis not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          feedZ1 = 0;
          movementZ = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Conical cycle", 0, 0);
          mylcd.Print_String("Insert the feed rate along the Z-axis", 0, 18);
          mylcd.Print_String("with the keypad", 0, 36);
          mylcd.Print_String("between 0.35 and 0.65 mm/rotation", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkFeedZ == 0);
  Serial.println(feedZ1);
  Serial.println(rotationalSpeedScrew);
  return feedZ1;
}