int multidiameter(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  delay(1000);

  sendEnableStart();
  enb_rot = 0;

  startDiameter = acquisitionInitialDiameterC();
  if(ok == 2){
    return;
  }

  do{
    finalDiameter1 = acquisitionSmallerDiameter(startDiameter);
    if(ok == 2){
      return;
    }
    delay(1000);

    finalDiameter2 = acquisitionGreaterDiameter(startDiameter);
    if(ok == 2){
      return;
    }
    delay(1000);
  }while(finalDiameter1 >= finalDiameter2);

  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  mylcd.Print_String("Initial diameter: " + String(startDiameter) + " mm", 0, 18);
  mylcd.Print_String("Smaller initial diameter: " + String(finalDiameter1) + " mm", 0, 36);
  feedX1 = checkFeedXC(startDiameter, finalDiameter1);
  nCycles1 = numberCycles;
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  mylcd.Print_String("Initial diameter: " + String(startDiameter) + " mm", 0, 18);
  mylcd.Print_String("Greater initial diameter: " + String(finalDiameter2) + " mm", 0, 36);
  feedX2 = checkFeedXC(startDiameter, finalDiameter2);
  nCycles2 = numberCycles; //number of cycles for the greater diameter (2), the first part to be proceeded

  cuttingSpeed = selectCuttingSpeedC();
  if(ok == 2){
    return;
  }
  delay(1000);
  avgFinalDiameter = (finalDiameter1 + finalDiameter2)/2;
  spindleSpeed = suggestSpindleSpeedC(avgFinalDiameter, cuttingSpeed);
  if(ok == 2){
    return;
  }
  delay(1000);
  feedZrough = feedRateZroughC(spindleSpeed); //with the feed rate along axis x, compute the rotational speed of the screw, speed to be inserted in the following functions
  if(ok == 2){
    return;
  }
  delay(1000);
  workingLengthTotal = acquisitionWorkingLengthC();
  if(ok == 2){
    return;
  }
  delay(1000);
  do{
    workingLength1 = acquisitionWorkingLengthMultiSmaller();
    if(ok == 2){
      return;
    }
    delay(1000);

    workingLength2 = acquisitionWorkingLengthMultiGreater();
    if(ok == 2){
      return;
    }
    delay(1000);
  }while((workingLength1 + workingLength2) != workingLengthTotal);

  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  delay(300);
  sendSpindleSpeed(); //send to the other Arduino the target speed through the serial communication
  if(ok == 2){
    return;
  }
  
  //check the position of the security window
  mylcd.Print_String("Close the window safely", 0, 72);
  lcd.clear();  lcd.print("Close the window");  lcd.setCursor(0,1);  lcd.print("safely");
  do{
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    delay(200);
  }while(startState == HIGH && secCheckState != HIGH);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }

  //enabling of the process and start of the rotation
  okEnable = 0;
  mylcd.Print_String("Press # to enable", 0, 108);
  mylcd.Print_String("the beginning of the process", 0, 126);
  lcd.clear();  lcd.print("Press # enabling");  lcd.setCursor(0,1);  lcd.print("the process");
  delay(1000);
  do{
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    delay(100);

    varEnable = '0';
    varEnable = customKeypad.getKey(); //acquisition of the command from the keypad
    if(varEnable && varEnable == '#'){
      sendEnableRotation();
      delay(1000);
      okEnable = 1;
    }
  }while(okEnable == 0 && startState == HIGH && secCheckState == HIGH);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }
  delay(1000);

  realSpindleSpeed = 0;
  do{
    realSpindleSpeed = receiveSpindleSpeed();
  }while(startState == HIGH && secCheckState == HIGH && realSpindleSpeed == 0);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }
  delay(1000);

  feedX2 = feedX2 - feedXfinish;
  positioningProcessC(workingLengthTotal, feedX2);
  if(ok == 2){
    return;
  }
  delay(1000);

  //roughing cycle to obtain the greatest diameter
  if(nCycles2 == 1){
    comebackVarZ = workingProcess1Cycle(workingLengthTotal, rotationalSpeedScrew); //only one cycle must be perfomed
  }else if(nCycles2 > 1){
    comebackVarZ = workingProcessMoreCycles(workingLengthTotal, rotationalSpeedScrew, feedX2); //more than 1 cycles must be perfomed
  }
  if(ok == 2){
    return;
  }
  delay(1000);

  //roughing cycle to obtain the smallest diameter
  feedX1 = feedX1 - feedX2 - 2*feedXfinish;
  if(feedX1 <= maxFeedX){
    nCycles1 = 1;
    feedX1 = feedX1 + feedX2 + feedXfinish;
    comebackVarZ = workingProcess1CycleSmall(workingLength1, rotationalSpeedScrew); //only one cycle must be perfomed
  }else{
    nCycles1 = (int)(feedX1/maxFeedX);
    ver = feedX1 - nCycles1*maxFeedX;
    if(ver != 0){
      nCycles1++;
    }
    feedX1 = feedX1 + feedX2 + feedXfinish;
    comebackVarZ = workingProcessMoreCyclesSmall(workingLength1, rotationalSpeedScrew, feedX1); //more than 1 cycles must be perfomed
  }
  if(ok == 2){
    return;
  }
  delay(1000);

  //finishing part
  feedZfinish = 0.4;
  rotationalSpeedScrew = (int) (feedZfinish*spindleSpeed*pitch);

  //finishing process for the smallest diameter
  comebackVarZ = finishProcess(workingLength1, rotationalSpeedScrew, (feedX2 + feedXfinish + feedX1));
  if(ok == 2){
    return;
  }
  delay(1000);

  //finishing process for the greatest diameter and consider the length 1
  comebackVarZ = finishProcess(workingLengthTotal, rotationalSpeedScrew, feedX2);
  if(ok == 2){
    return;
  }
  delay(1000);

  //send to the other Arduino the command to stop the rotation
  sendStop();
  delay(1000);

  backHome(comebackVarZ,comebackVarX);
  delay(1000);

  //check the position of the security window
  mylcd.Print_String("Open the window safely", 0, 126);
  lcd.clear();  lcd.print("Open the window");  lcd.setCursor(0,1);  lcd.print("safely");
  do{
    secCheckState = digitalRead(secCheckPin);
    delay(200);
  }while(secCheckState != LOW);

  mylcd.Print_String("Ready for a new process", 0, 162);
  lcd.clear();  lcd.print("Ready for a new");  lcd.setCursor(0,1);  lcd.print("workcycle");
  delay(2000);  
  
  ok = 1;
  return ok;
}