//for complete
void positioningProcessB(float cycleLength, float feedAlongX){ //function to position the tool near the piece to work/to the starting position
  do{
    checkOverallDistance = 0;

    mylcd.Fill_Screen(BLUE);
    mylcd.Print_String("Cylindrical complete cycle", 0, 0);
    mylcd.Print_String("Measure of the distance:", 0, 18);

    //measurement of the distance of the working piece from the starting point through the usage of the ultrasonic sensor
    //Acquire 100 measures and perform the average
    for(int i=0; i<101; i++){
      digitalWrite(trigPin, LOW);
      delayMicroseconds(2);
      digitalWrite(trigPin, HIGH);
      delayMicroseconds(10);
      digitalWrite(trigPin, LOW);
      duration = pulseIn(echoPin, HIGH); //acquire the starting instant of time when the echoPin changes state to HIGH and stop the acquisition of time when the state changes to LOW
      distance = (duration*0.343)/2;
      measures[i] = distance;
      delay(100);
    }
    sum = 0;
    averageDistance = 0;
    for(int i=1; i<101; i++){ //compute the average value among all the measures acquired
      sum = sum + measures[i];
    }
    averageDistance = sum/100;
    positioning = averageDistance - extra_len; //take into account an extra-distance of 5 mm from the piece
    tot_distance = averageDistance + cycleLength;
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(tot_distance <= maxLength){ //accepted lenghts
      lcd.clear();      lcd.print("Distance:");      lcd.setCursor(0,1);      lcd.print(String(averageDistance) + " mm");
      mylcd.Print_String("Measure of the distance: "+ String(averageDistance) + " mm", 0, 18);
      delay(1000);
      checkOverallDistance = 1;
    }else{ //in case of an error
      mylcd.Fill_Screen(BLUE);
      mylcd.Print_String("Cylindrical complete cycle", 0, 0);
      mylcd.Print_String("ERROR in the positioning!", 0, 18);
      lcd.clear();      lcd.print("ERROR! Press a");      lcd.setCursor(0,1);      lcd.print("new command:");
      delay(2000);
    }
  }while(checkOverallDistance == 0 && startState == HIGH && secCheckState == HIGH);
  if(startState == LOW || secCheckState == LOW){
    Emergency();
    ok = 2;
    return;
  }

  mylcd.Print_String("Positioning of the tool", 0, 36);
  lcd.clear();  lcd.print("Positioning");  lcd.setCursor(0,1);  lcd.print("of the tool");
  delay(500);

  Serial.print(averageDistance);
  Serial.print("\t");
  Serial.print(extra_len);
  Serial.print("\t");
  Serial.println(positioning);

  //move along the longitudinal axis (Z-axis)
  pulsesZ = NpulsesRevolutionZ*positioning/pitch;
  Serial.print(pulsesZ);
  Serial.print("\t");

  lcd.clear();
  mylcd.Print_String("Moving along the Z-axis:", 0, 54);
  distanceZ = 0.00;
  comebackVarZ = 0;
  countZ = 0;
  digitalWrite(dirPin,HIGH);
  for(int i=0; i<pulsesZ; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(halfT_screw);
    digitalWrite(stepPin,LOW); 
    delayMicroseconds(halfT_screw);
    comebackVarZ++;
    countZ++;
    if(countZ == NpulsesRevolutionZ){
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = 0;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceZ = positioning;
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  mylcd.Print_String("Z position: " + String(distanceZ) + "/" + String(positioning) + " mm", 0, 72);
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  Serial.println(comebackVarZ); //pulses needed for the positioning of the tool
  delay(500);

  //positioning of the tool along the X-axis: from the home position to the initial diameter
  mylcd.Print_String("Moving along the X-axis:", 0, 108);

  positionXaxis = xHome + (maximumDiameter - startDiameter)/2;
  pulsesPosX = positionXaxis*gearRatio*360/(pitch*angleX);
  Serial.println(positionXaxis);
  Serial.print(pulsesPosX);
  Serial.print("\t");

  comebackVarX = 0;
  distanceX = 0.00;
  countX = 0;
  delayMotor = 2;
  for(int i=0; i<pulsesPosX; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Forward();
    comebackVarX++;
    countX++;
    if(countX == NpulsesRevolutionX){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = 0;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 126);
  lcd.setCursor(0,1);      
  lcd.print("X pos: " + String(distanceX)  + " mm");
  Serial.println(comebackVarX);
  delay(500);

  //move along the trasversal axis (X-axis) to reach the desired feed X (movement corresponding to the distance initial diameter-feed X)
  mylcd.Print_String("Position along the X-axis of the feed:", 0, 162);
  if(feedAlongX <= maxFeedX){
    pulsesX = feedAlongX*gearRatio*360/(pitch*angleX);
    Serial.println(feedAlongX);
    Serial.print(pulsesX);
    Serial.print("\t");
    
    internVarX = 0;
    delayMotor = 2;
    for(int i=0; i<pulsesX; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Forward();
      comebackVarX++;
      internVarX++;
      countX++;
      if(countX == NpulsesRevolutionX){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = 0;
        lcd.setCursor(0,1);
        lcd.print("X pos: " + String(distanceX) + " mm");
      }
    }
    distanceX = feedAlongX;
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 180);
    lcd.setCursor(0,1);
    lcd.print("X pos: " + String(distanceX)  + " mm");
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delay(1000);
  }else if(feedAlongX > maxFeedX){
    pulsesX = maxFeedX*gearRatio*360/(pitch*angleX);
    Serial.print(feedAlongX);
    Serial.print("\t");
    Serial.print(pulsesX);

    internVarX = 0;
    delayMotor = 2;
    for(int i=0; i<pulsesX; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Forward();
      comebackVarX++;
      internVarX++;
      countX++;
      if(countX == NpulsesRevolutionX){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = 0;
        lcd.setCursor(0,1);
        lcd.print("X pos: " + String(distanceX) + "mm");
      }
    }
    distanceX = maxFeedX;
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 180);
    lcd.setCursor(0,1);
    lcd.print("X pos: " + String(distanceX) + " mm");
    Serial.print("\t");
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delay(1000);
  }
}

//for multidiameter
void positioningProcessC(float cycleLength, float feedAlongX){ //function to position the tool near the piece to work/to the starting position
  do{
    checkOverallDistance = 0;

    mylcd.Fill_Screen(BLUE);
    mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
    mylcd.Print_String("Measure of the distance:", 0, 18);

    lcd.clear();    lcd.print("Measuring the");    lcd.setCursor(0,1);    lcd.print("distance...");

    //measurement of the distance of the working piece from the starting point through the usage of the ultrasonic sensor
    //Acquire 100 measures and perform the average
    for(int i=0; i<101; i++){
      digitalWrite(trigPin, LOW);
      delayMicroseconds(2);
      digitalWrite(trigPin, HIGH);
      delayMicroseconds(10);
      digitalWrite(trigPin, LOW);
      duration = pulseIn(echoPin, HIGH); //acquire the starting instant of time when the echoPin changes state to HIGH and stop the acquisition of time when the state changes to LOW
      distance = (duration*0.343)/2;
      measures[i] = distance;
      delay(100);
    }
    sum = 0;
    averageDistance = 0;
    for(int i=1; i<101; i++){ //compute the average value among all the measures acquired
      sum = sum + measures[i];
    }
    averageDistance = sum/100;
    positioning = averageDistance - extra_len; //take into account an extra-distance of 5 mm from the piece
    tot_distance = averageDistance + cycleLength;
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(tot_distance <= maxLength){ //accepted lenghts
      lcd.clear();      lcd.print("Distance:");      lcd.setCursor(0,1);      lcd.print(String(averageDistance) + " mm");
      mylcd.Print_String("Measure of the distance: "+ String(averageDistance) + " mm", 0, 18);
      delay(1000);
      checkOverallDistance = 1;
    }else{ //in case of an error
      mylcd.Fill_Screen(BLUE);
      mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
      mylcd.Print_String("ERROR in the positioning!", 0, 18);
      lcd.clear();      lcd.print("ERROR! Press a");      lcd.setCursor(0,1);      lcd.print("new command:");
      delay(2000);
    }
  }while(checkOverallDistance == 0 && startState == HIGH && secCheckState == HIGH);
  if(ok == 2){
    return;
  }
  delay(1000);
  
  mylcd.Print_String("Positioning of the tool", 0, 36);
  lcd.clear();  lcd.print("Positioning");  lcd.setCursor(0,1);  lcd.print("of the tool");
  delay(500);

  Serial.print(averageDistance);
  Serial.print("\t");
  Serial.print(extra_len);
  Serial.print("\t");
  Serial.println(positioning);

  //move along the longitudinal axis (Z-axis)
  pulsesZ = NpulsesRevolutionZ*positioning/pitch;
  Serial.print(pulsesZ);
  Serial.print("\t");

  lcd.clear();
  mylcd.Print_String("Moving along the Z-axis:", 0, 54);
  distanceZ = 0.00;
  comebackVarZ = 0;
  countZ = 0;
  digitalWrite(dirPin,HIGH);
  for(int i=0; i<pulsesZ; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(halfT_screw);
    digitalWrite(stepPin,LOW); 
    delayMicroseconds(halfT_screw);
    comebackVarZ++;
    countZ++;
    if(countZ == NpulsesRevolutionZ){
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = 0;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceZ = positioning;
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  mylcd.Print_String("Z position: " + String(distanceZ) + "/" + String(positioning) + " mm", 0, 72);
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  Serial.println(comebackVarZ); //pulses needed for the positioning of the tool
  delay(500);

  //positioning of the tool along the X-axis: from the home position to the initial diameter
  mylcd.Print_String("Moving along the X-axis:", 0, 108);

  comebackVarX = 0;
  positionXaxis = xHome + (maximumDiameter - startDiameter)/2;
  pulsesPosX = positionXaxis*gearRatio*360/(pitch*angleX);
  Serial.println(positionXaxis);
  Serial.print(pulsesPosX);
  Serial.print("\t");

  delayMotor = 2;
  distanceX = 0.00;
  countX = 0;
  for(int i=0; i<pulsesPosX; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Forward();
    comebackVarX++;
    countX++;
    if(countX == NpulsesRevolutionX){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = 0;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 126);
  lcd.setCursor(0,1);      
  lcd.print("X pos: " + String(distanceX)  + " mm");
  Serial.println(comebackVarX);
  delay(500);

  //move along the trasversal axis (X-axis) to reach the desired feed X (movement corresponding to the distance initial diameter-feed X)
  mylcd.Print_String("Position along the X-axis of the feed:", 0, 162);
  if(feedAlongX <= maxFeedX){
    pulsesX = feedAlongX*gearRatio*360/(pitch*angleX);
    Serial.println(feedAlongX);
    Serial.print(pulsesX);
    Serial.print("\t");
    
    internVarX = 0;
    delayMotor = 2;
    for(int i=0; i<pulsesX; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Forward();
      comebackVarX++;
      internVarX++;
      countX++;
      if(countX == NpulsesRevolutionX){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = 0;
        lcd.setCursor(0,1);
        lcd.print("X pos: " + String(distanceX)  + " mm");
      }
    }
    distanceX = feedAlongX;
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 180);
    lcd.setCursor(0,1);
    lcd.print("X pos: " + String(distanceX)  + " mm");
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delay(1000);
  }else if(feedAlongX > maxFeedX){
    pulsesX = maxFeedX*gearRatio*360/(pitch*angleX);
    Serial.print(feedAlongX);
    Serial.print("\t");
    Serial.print(pulsesX);

    internVarX = 0;
    delayMotor = 2;
    for(int i=0; i<pulsesX; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Forward();
      comebackVarX++;
      internVarX++;
      countX++;
      if(countX == NpulsesRevolutionX){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = 0;
        lcd.setCursor(0,1);
        lcd.print("X pos: " + String(distanceX) + "mm");
      }
    }
    distanceX = maxFeedX;
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 180);
    lcd.setCursor(0,1);
    lcd.print("X pos: " + String(distanceX)  + " mm");
    Serial.print("\t");
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delay(1000);
  }
}

//for conical
void positioningProcessD(float cycleLength, float feedAlongX){ //function to position the tool near the piece to work/to the starting position
  do{
    checkOverallDistance = 0;

    mylcd.Fill_Screen(BLUE);
    mylcd.Print_String("Conical cycle", 0, 0);
    mylcd.Print_String("Measure of the distance:", 0, 18);

    lcd.clear();    lcd.print("Measuring the");    lcd.setCursor(0,1);    lcd.print("distance...");

    //measurement of the distance of the working piece from the starting point through the usage of the ultrasonic sensor
    //Acquire 100 measures and perform the average
    for(int i=0; i<101; i++){
      digitalWrite(trigPin, LOW);
      delayMicroseconds(2);
      digitalWrite(trigPin, HIGH);
      delayMicroseconds(10);
      digitalWrite(trigPin, LOW);
      duration = pulseIn(echoPin, HIGH); //acquire the starting instant of time when the echoPin changes state to HIGH and stop the acquisition of time when the state changes to LOW
      distance = (duration*0.343)/2;
      measures[i] = distance;
      delay(100);
    }
    sum = 0;
    averageDistance = 0;
    for(int i=1; i<101; i++){ //compute the average value among all the measures acquired
      sum = sum + measures[i];
    }
    averageDistance = sum/100;
    positioning = averageDistance - extra_len; //take into account an extra-distance of 5 mm from the piece
    tot_distance = averageDistance + cycleLength;
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(tot_distance <= maxLength){ //accepted lenghts
      lcd.clear();      lcd.print("Distance:");      lcd.setCursor(0,1);      lcd.print(String(averageDistance) + " mm");
      //mylcd.Fill_Screen(BLUE);
      mylcd.Print_String("Measure of the distance: "+ String(averageDistance) + " mm", 0, 18);
      delay(1000);
      checkOverallDistance = 1;
    }else{ //in case of an error
      mylcd.Fill_Screen(BLUE);
      mylcd.Print_String("Conical cycle", 0, 0);
      mylcd.Print_String("ERROR in the positioning!", 0, 18);
      lcd.clear();      lcd.print("ERROR! Press a");      lcd.setCursor(0,1);      lcd.print("new command:");
      delay(2000);
    }
  }while(checkOverallDistance == 0 && startState == HIGH && secCheckState == HIGH);
  if(ok == 2){
    return;
  }
  delay(1000);

  mylcd.Print_String("Positioning of the tool", 0, 36);
  lcd.clear();  lcd.print("Positioning");  lcd.setCursor(0,1);  lcd.print("of the tool");
  delay(500);

  Serial.print(averageDistance);
  Serial.print("\t");
  Serial.print(extra_len);
  Serial.print("\t");
  Serial.println(positioning);

  //move along the longitudinal axis (Z-axis)
  pulsesZ = NpulsesRevolutionZ*positioning/pitch;
  Serial.print(pulsesZ);
  Serial.print("\t");

  lcd.clear();
  mylcd.Print_String("Moving along the Z-axis:", 0, 54);
  distanceZ = 0.00;
  comebackVarZ = 0;
  countZ = 0;
  digitalWrite(dirPin,HIGH);
  for(int i=0; i<pulsesZ; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(halfT_screw);
    digitalWrite(stepPin,LOW); 
    delayMicroseconds(halfT_screw);
    comebackVarZ++;
    countZ++;
    if(countZ == NpulsesRevolutionZ){
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = 0;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceZ = positioning;
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  mylcd.Print_String("Z position: " + String(distanceZ) + "/" + String(positioning) + " mm", 0, 72);
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  Serial.println(comebackVarZ); //pulses needed for the positioning of the tool
  delay(500);

  //positioning of the tool along the X-axis: from the home position to the initial diameter
  mylcd.Print_String("Moving along the X-axis:", 0, 108);

  comebackVarX = 0;
  positionXaxis = xHome + (maximumDiameter - startDiameter)/2;
  pulsesPosX = positionXaxis*gearRatio*360/(pitch*angleX);
  Serial.println(positionXaxis);
  Serial.print(pulsesPosX);
  Serial.print("\t");

  delayMotor = 2;
  distanceX = 0.00;
  countX = 0;
  for(int i=0; i<pulsesPosX; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Forward();
    comebackVarX++;
    countX++;
    if(countX == NpulsesRevolutionX){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = 0;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 126);
  lcd.setCursor(0,1);      
  lcd.print("X pos: " + String(distanceX)  + " mm");
  Serial.println(comebackVarX);
  delay(500);

  //move along the trasversal axis (X-axis) to reach the desired feed X (movement corresponding to the distance initial diameter-feed X)
  mylcd.Print_String("Position along the X-axis of the feed:", 0, 162);
  if(feedAlongX <= maxFeedX){
    pulsesX = feedAlongX*gearRatio*360/(pitch*angleX);
    Serial.println(feedAlongX);
    Serial.print(pulsesX);
    Serial.print("\t");
    
    internVarX = 0;
    delayMotor = 2;
    for(int i=0; i<pulsesX; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Forward();
      comebackVarX++;
      internVarX++;
      countX++;
      if(countX == NpulsesRevolutionX){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = 0;
        lcd.setCursor(0,1);
        lcd.print("X pos: " + String(distanceX) + " mm");
      }
    }
    distanceX = feedAlongX;
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 180);
    lcd.setCursor(0,1);
    lcd.print("X pos: " + String(distanceX)  + " mm");
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delay(1000);
  }else if(feedAlongX > maxFeedX){
    pulsesX = maxFeedX*gearRatio*360/(pitch*angleX);
    Serial.print(feedAlongX);
    Serial.print("\t");
    Serial.print(pulsesX);

    internVarX = 0;
    delayMotor = 2;
    for(int i=0; i<pulsesX; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Forward();
      comebackVarX++;
      internVarX++;
      countX++;
      if(countX == NpulsesRevolutionX){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = 0;
        lcd.setCursor(0,1);
        lcd.print("X pos: " + String(distanceX) + "mm");
      }
    }
    distanceX = maxFeedX;
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    mylcd.Print_String("X position: " + String(distanceX) + " mm", 0, 180);
    lcd.setCursor(0,1);
    lcd.print("X pos: " + String(distanceX) + " mm");
    Serial.print("\t");
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delay(1000);
  }
}