void sendSpindleSpeed(){
  Serial3.println(spindleSpeed);
  do{
    enb_spd = receiveEnableSpeed();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
  }while(startState == HIGH && secCheckState == LOW && enb_spd == 0);

  if(startState == LOW || secCheckState == HIGH){
    Emergency();
    ok = 2;
    return; 
  }
  mylcd.Print_String("Transmission of the spindle", 0, 18);
  mylcd.Print_String("speed complete", 0, 36);
  delay(500);
}

int receiveEnableSpeed(){
  receiveOK = 0;
  enb_spd = 0;
  do{
    if(Serial3.available()>0) { // Check if data is available to read
      String receivedString = Serial3.readStringUntil('\n'); // Read the incoming data until newline character
      enb_spd = receivedString.toInt(); // Convert the received string to an integer for the target speed of the motor
      if(enb_spd == 1){ //check if the speed can be accepted or not, decide a minimum and a maximum value
        receiveOK = 1;
      }
    }
    startState = digitalRead(startPin);
  }while(startState == HIGH && receiveOK == 0);

  Serial.println(enb_spd);
  delay(1000);
  return enb_spd;
}

int receiveSpindleSpeed(){ //to acquire the speed or with the reading of a digital signal (when it triggers, it means that the right speed has been reached)
  okSpeed = 0;
  realSpindleSpeed = 0;
  do{
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    
    if(Serial3.available()>0){ // Check if data is available to read
      String receivedControlSpeed = Serial3.readStringUntil('\n'); // Read the incoming data until newline character
      realSpindleSpeed = receivedControlSpeed.toInt(); // Convert the received string to an integer
      if((realSpindleSpeed >= targetMin) && (realSpindleSpeed <= targetMax)){
        okSpeed = 1;
        mylcd.Print_String("Real spindle speed: " + String(realSpindleSpeed), 0, 162);
        Serial.print("Received speed: ");
        Serial.println(realSpindleSpeed);
        lcd.clear();
        lcd.print("Speed:");
        lcd.setCursor(0,1);
        lcd.print(String(realSpindleSpeed) + " rpm");
      }
    }
  }while(okSpeed == 0 && startState == HIGH && secCheckState == HIGH);

  return realSpindleSpeed;
}