//for roughing, complete
long workingProcess1Cycle(float length, int screwSpeed){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Working roughing cycle:", 0, 0);
  delay(500);

  pulses = NpulsesRevolutionZ*(length + extra_len)/pitch;

  distanceCovered = 0.00;
  internVarZ = 0;
  //count = 0;
  halfperiodSpeed = 60*1e6;
  halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
  halfperiodSpeed = halfperiodSpeed/screwSpeed;
  periodSpeed = (int) halfperiodSpeed;
  Serial.print(halfperiodSpeed);
  Serial.print("\t");
  Serial.println(periodSpeed);

  Serial.println(length + extra_len);
  Serial.print(pulses);
  digitalWrite(dirPin,HIGH);
  for(int i=0; i<pulses; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(periodSpeed);
    digitalWrite(stepPin,LOW); 
    delayMicroseconds(periodSpeed);
    comebackVarZ++;
    internVarZ++;
    countZ++;
    if(countZ == NpulsesRevolutionZ){
      distanceCovered++;
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = 0;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceCovered = length + extra_len;
  distanceZ = positioning + distanceCovered;
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  mylcd.Print_String("Worklength: " + String(length) + "/" + String(length) + " mm", 0, 18);
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  Serial.print("\t");
  Serial.print(comebackVarZ);
  Serial.print("\t");
  Serial.println(internVarZ);

  mylcd.Print_String("Return phase", 0, 54);
  mylcd.Print_String("Move back along X-axis", 0, 72);
  Serial.print(comebackVarX);
  Serial.print("\t");
  Serial.println(internVarX);
  delayMotor = 2;
  for(int i=0; i<internVarX; i++){ //move back as soon as the stage is completed
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Backward();
    comebackVarX--;
    countX--;
    if(countX == 0){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = NpulsesRevolutionX;
      lcd.setCursor(0,1);   
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  lcd.setCursor(0,1);   
  lcd.print("X pos: " + String(distanceX)  + " mm");
  delay(500);

  mylcd.Print_String("Move back along Z-axis", 0, 90);
  Serial.println(comebackVarZ);
  digitalWrite(dirPin,LOW);
  for(int i=0; i<internVarZ; i++){ //move back till the position including the extralength
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(halfT_screw);
    digitalWrite(stepPin,LOW);
    delayMicroseconds(halfT_screw);
    comebackVarZ--;
    countZ--;
    if(countZ == 0){
      distanceCovered++;
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  return comebackVarZ;
}

//for complete
long workingProcessMoreCycles(float length, int screwSpeed, float feedXaxis){
  delay(500);

  pulses = NpulsesRevolutionZ*(length + extra_len)/pitch;
  
  for(int Ncycle=0; Ncycle<numberCycles; Ncycle++){
    mylcd.Fill_Screen(BLUE);
    mylcd.Print_String("Working roughing cycle:", 0, 0);
    mylcd.Print_String("Cycle number: " + String(Ncycle+1), 0, 18);
    distanceCovered = 0.00;
    internVarZ = 0;
    halfperiodSpeed = 60*1e6;
    halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
    halfperiodSpeed = halfperiodSpeed/screwSpeed;
    periodSpeed = (int) halfperiodSpeed;
    Serial.print(halfperiodSpeed);
    Serial.print("\t");
    Serial.println(periodSpeed);

    Serial.print(length + extra_len);
    Serial.print("\t");
    Serial.print(pulses);
    Serial.print("\t");
    digitalWrite(dirPin,HIGH);
    for(int i=0; i<pulses; i++) { // Makes 200 pulses for making one full cycle rotation
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(periodSpeed);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(periodSpeed);
      comebackVarZ++;
      internVarZ++;
      countZ++;
      if(countZ == NpulsesRevolutionZ){
        distanceCovered++;
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = 0;   
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
    distanceCovered = length + extra_len;
    distanceZ = positioning + distanceCovered;
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    mylcd.Print_String("Z-position: " + String(distanceCovered) + " mm", 0, 36);
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");
    Serial.print(comebackVarZ);
    Serial.print("\t");
    Serial.println(internVarZ);

    mylcd.Print_String("Return phase", 0, 72);
    mylcd.Print_String("Move back along X-axis", 0, 90);
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delayMotor = 2;
    for(int i=0; i<internVarX; i++){ //move back as soon as the stage is completed
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Backward();
      comebackVarX--;
      countX--;
      if(countX == 0){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = NpulsesRevolutionX;
        lcd.setCursor(0,1);      
        lcd.print("X pos: " + String(distanceX)  + " mm");
      }
    }
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    lcd.setCursor(0,1);      
    lcd.print("X pos: " + String(distanceX)  + " mm");
    delay(500);

    mylcd.Print_String("Move back along Z-axis", 0, 108);
    Serial.println(comebackVarZ);
    digitalWrite(dirPin,LOW);
    for(int i=0; i<internVarZ; i++) {
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(halfT_screw);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(halfT_screw);
      comebackVarZ--; 
      countZ--;
      if(countZ == 0){
        distanceCovered++;
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = NpulsesRevolutionZ;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");

    //re-positioning along the X-axis
    nC = Ncycle+2;
    if(nC < numberCycles){
      mylcd.Print_String("Position along the X-axis of the feed:", 0, 144);
      pulsesX = maxFeedX*NpulsesRevolutionX*(Ncycle+2);
      internVarX = pulsesX;
      Serial.print(pulsesX);
      Serial.print("\t");
      delayMotor = 2;
      for(int i=0; i<pulsesX; i++){ //move forward as soon as the stage is completed
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);      
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      mylcd.Print_String("X-position: " + String(distanceX) + " mm", 0, 162);
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(comebackVarX);
      Serial.print("\t");
      Serial.println(internVarX);
      delay(1000);
    }else if(nC == numberCycles){
      mylcd.Print_String("Position along the X-axis of the feed:", 0, 144);
      pulsesX = (int) NpulsesRevolutionX*feedXaxis;
      internVarX = pulsesX;
      Serial.print(feedXaxis);
      Serial.print("\t");
      Serial.print(pulsesX);
      Serial.print("\t");
      delayMotor = 2;
      for(int i=0; i<internVarX; i++){ //move forward to perform the last repetition
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);      
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      mylcd.Print_String("X-position: " + String(feedXaxis) + " mm", 0, 162);
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(comebackVarX);
      Serial.print("\t");
      Serial.println(internVarX);
      delay(1000);
    }
  }
  return comebackVarZ;
}

//for multidimensional small diameter
long workingProcess1CycleSmall(float length, int screwSpeed){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Working roughing cycle:", 0, 0);
  delay(500);

  mylcd.Print_String("Position along the X-axis of the feed:", 0, 18);
  internVarX = (feedX1)*NpulsesRevolutionX/pitch;
  Serial.print(feedX1);
  Serial.print("\t");
  Serial.print(internVarX);
  Serial.print("\t");
  for(int i=0; i<internVarX; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Forward();
    comebackVarX++;
    countX++;
    if(countX == NpulsesRevolutionX){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = 0;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  mylcd.Print_String("X-position: " + String(feedX1+ feedXfinish) + " mm", 0, 36);
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  lcd.setCursor(0,1);      
  lcd.print("X pos: " + String(distanceX)  + " mm");
  Serial.print(comebackVarX);
  Serial.print("\t");
  Serial.println(internVarX);

  pulses = NpulsesRevolutionZ*(length + extra_len)/pitch;
  Serial.print(length + extra_len);
  Serial.print("\t");
  Serial.print(pulses);
  Serial.print("\t");

  distanceCovered = 0.00;
  internVarZ = 0;
  halfperiodSpeed = 60*1e6;
  halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
  halfperiodSpeed = halfperiodSpeed/screwSpeed;
  periodSpeed = (int) halfperiodSpeed;
  Serial.print(halfperiodSpeed);
  Serial.print("\t");
  Serial.println(periodSpeed);
  
  digitalWrite(dirPin,HIGH);
  for(int i=0; i<pulses; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(periodSpeed);
    digitalWrite(stepPin,LOW); 
    delayMicroseconds(periodSpeed);
    comebackVarZ++;
    internVarZ++;
    countZ++;
    if(countZ == NpulsesRevolutionZ){
      distanceCovered++;
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = 0;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceCovered = length + extra_len;
  distanceZ = positioning + distanceCovered;
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  mylcd.Print_String("Z-position: " + String(distanceCovered) + "/" + String(length) + " mm", 0, 72);
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  Serial.print(comebackVarZ);
  Serial.print("\t");
  Serial.println(internVarZ);
  delay(500);

  mylcd.Print_String("Return phase", 0, 108);
  mylcd.Print_String("Move back along X-axis", 0, 126);
  Serial.println(comebackVarX);
  delayMotor = 2;
  for(int i=0; i<internVarX; i++){ //move back as soon as the stage is completed
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Backward();
    comebackVarX--;
    countX--;
    if(countX == 0){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = NpulsesRevolutionX;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  lcd.setCursor(0,1);      
  lcd.print("X pos: " + String(distanceX)  + " mm");
  delay(500);

  mylcd.Print_String("Move back along Z-axis", 0, 144);
  Serial.println(comebackVarZ);
  digitalWrite(dirPin,LOW);
  for(int i=0; i<internVarZ; i++){ //move back till the position including the extralength
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(halfT_screw);
    digitalWrite(stepPin,LOW);
    delayMicroseconds(halfT_screw);
    comebackVarZ--;
    countZ--;
    if(countZ == 0){
      distanceCovered++;
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  return comebackVarZ;
}

//for multidimensional small diam
long workingProcessMoreCyclesSmall(float length, int screwSpeed, float feedXaxis){
  delay(500);

  pulses = NpulsesRevolutionZ*(length + extra_len)/pitch;
  
  for(int Ncycle=0; Ncycle<numberCycles; Ncycle++){
    mylcd.Fill_Screen(BLUE);
    mylcd.Print_String("Working roughing cycle:", 0, 0);
    mylcd.Print_String("Cycle number: " + String(Ncycle+1), 0, 18);

    //re-positioning along the X-axis
    nC = Ncycle+1;
    if(nC < numberCycles){
      mylcd.Print_String("Position along the X-axis of the feed:", 0, 36);
      internVarX = (maxFeedX*nC + feedX2 + feedXfinish)*NpulsesRevolutionX/pitch;
      Serial.println(maxFeedX + feedX2 + feedXfinish);
      Serial.println("\t");
      Serial.println(internVarX);
      delayMotor = 2;
      for(int i=0; i<internVarX; i++){ //move forward as soon as the stage is completed
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);      
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      mylcd.Print_String("X-position: " + String(maxFeedX) + " mm", 0, 54);
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(comebackVarX);
      Serial.print("\t");
      Serial.println(internVarX);
      delay(500);
    }else if(nC == numberCycles){
      mylcd.Print_String("Position along the X-axis of the feed:", 0, 36);
      pulsesX = (feedXaxis)*NpulsesRevolutionX/pitch;
      internVarX = pulsesX;
      Serial.print(feedXaxis);
      Serial.print("\t");
      Serial.print(internVarX);
      delayMotor = 2;
      for(int i=0; i<internVarX; i++){ //move forward to perform the last repetition
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);      
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      mylcd.Print_String("X-position: " + String(maxFeedX) + " mm", 0, 54);
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(comebackVarX);
      Serial.print("\t");
      Serial.println(internVarX);
      delay(500);
    }

    Serial.print(length + extra_len);
    Serial.print("\t");
    Serial.print(pulses);
    Serial.print("\t");
    distanceCovered = 0.00;
    internVarZ = 0;
    halfperiodSpeed = 60*1000000;
    halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
    halfperiodSpeed = halfperiodSpeed/screwSpeed;
    periodSpeed = (int) halfperiodSpeed;
    Serial.print(halfperiodSpeed);
    Serial.print("\t");
    Serial.println(periodSpeed);

    digitalWrite(dirPin,HIGH);
    for(int i=0; i<pulses; i++) { // Makes 200 pulses for making one full cycle rotation
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(periodSpeed);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(periodSpeed);
      comebackVarZ++;
      internVarZ++;
      countZ++;
      if(countZ == NpulsesRevolutionZ){
        distanceCovered++;
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = 0;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
    distanceCovered = length + extra_len;
    distanceZ = positioning + distanceCovered;
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    mylcd.Print_String("Z-position: " + String(distanceCovered) + " mm", 0, 72);
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");
    Serial.print(comebackVarZ);
    Serial.print("\t");
    Serial.println(internVarZ);
    delay(500);

    mylcd.Print_String("Return phase", 0, 108);
    mylcd.Print_String("Move back along X-axis", 0, 126);
    Serial.println(comebackVarX);
    delayMotor = 2;
    for(int i=0; i<internVarX; i++){ //move back as soon as the stage is completed
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Backward();
      comebackVarX--;
      countX--;
      if(countX == 0){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = NpulsesRevolutionX;
        lcd.setCursor(0,1);      
        lcd.print("X pos: " + String(distanceX)  + " mm");
      }
    }
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    lcd.setCursor(0,1);      
    lcd.print("X pos: " + String(distanceX)  + " mm");
    delay(1000);

    mylcd.Print_String("Move back along Z-axis", 0, 144);
    Serial.println(comebackVarZ);
    digitalWrite(dirPin,LOW);
    for(int i=0; i<internVarZ; i++) {
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(halfT_screw);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(halfT_screw);
      comebackVarZ--;
      countZ--;
      if(countZ == 0){
        distanceCovered++;
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = NpulsesRevolutionZ;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
  }
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  return comebackVarZ;
}

long finishProcess(float length, int screwSpeed, float feedXaxis){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Working finishing cycle:", 0, 0);
  delay(500);

  mylcd.Print_String("Position along the X-axis of the feed:", 0, 18);
  pulsesX = (feedXaxis + feedXfinish)*gearRatio*360/(pitch*angleX);
  internVarX = pulsesX;
  delayMotor = 2;
  for(int i=0; i<internVarX; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Forward();
    comebackVarX++;
    countX++;
    if(countX == NpulsesRevolutionX){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = 0;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  mylcd.Print_String("X-position: " + String(feedXaxis + feedXfinish) + " mm", 0, 36);
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  lcd.setCursor(0,1);      
  lcd.print("X pos: " + String(distanceX)  + " mm");
  delay(1000);
  Serial.print(feedXaxis + feedXfinish);
  Serial.print("\t");
  Serial.print(pulsesX);
  Serial.print("\t");
  Serial.print(internVarX);
  Serial.print("\t");
  Serial.println(comebackVarX);

  pulses = NpulsesRevolutionZ*(length + extra_len)/pitch;
  Serial.print(length + extra_len);
  Serial.print("\t");
  Serial.print(pulses);
  Serial.print("\t");

  distanceCovered = 0.00;
  internVarZ = 0;
  halfperiodSpeed = 60*1e6;
  halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
  halfperiodSpeed = halfperiodSpeed/screwSpeed;
  periodSpeed = (int) halfperiodSpeed;
  Serial.print(halfperiodSpeed);
  Serial.print("\t");
  Serial.println(periodSpeed);
  
  digitalWrite(dirPin,HIGH);
  for(int i=0; i<pulses; i++) { // Makes 200 pulses for making one full cycle rotation
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(periodSpeed);
    digitalWrite(stepPin,LOW); 
    delayMicroseconds(periodSpeed);
    comebackVarZ++;
    internVarZ++;
    countZ++;
    if(countZ == NpulsesRevolutionZ){
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = 0;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceCovered = length + extra_len;
  distanceZ = positioning + distanceCovered;
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  mylcd.Print_String("Z-position: " + String(distanceCovered) + "/" + String(length) + " mm", 0, 54);
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  Serial.print(comebackVarZ);
  Serial.print("\t");
  Serial.println(internVarZ);
  delay(500);

  mylcd.Print_String("Return phase", 0, 90);
  mylcd.Print_String("Move back along X-axis", 0, 108);
  Serial.println(internVarX);
  delayMotor = 2;
  for(int i=0; i<internVarX; i++){ //move back as soon as the stage is completed
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    Backward();
    comebackVarX--;
    countX--;
    if(countX == 0){
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      countX = NpulsesRevolutionX;
      lcd.setCursor(0,1);      
      lcd.print("X pos: " + String(distanceX)  + " mm");
    }
  }
  distanceX = (float) comebackVarX/NpulsesRevolutionX;
  lcd.setCursor(0,1);      
  lcd.print("X pos: " + String(distanceX)  + " mm");
  delay(500);

  mylcd.Print_String("Move back along Z-axis", 0, 126);
  Serial.println(comebackVarZ);
  digitalWrite(dirPin,LOW);
  for(int i=0; i<internVarZ; i++){
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);
    if(startState == LOW || secCheckState == LOW){
      Emergency();
      ok = 2;
      return;
    }
    digitalWrite(stepPin,HIGH);
    delayMicroseconds(halfT_screw);
    digitalWrite(stepPin,LOW); 
    delayMicroseconds(halfT_screw);
    comebackVarZ--;
    countZ--;
    if(countZ == 0){
      distanceCovered++;
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      countZ = NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
    }
  }
  distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
  lcd.home();
  lcd.print("Z pos: " + String(distanceZ) + " mm");
  return comebackVarZ;
}

long workingProcessMoreCyclesCyl(float length, int screwSpeed){
  delay(500);

  for(int Ncycle=0; Ncycle<numberCyclesCyl; Ncycle++){
    mylcd.Fill_Screen(BLUE);
    mylcd.Print_String("Working roughing cycle:", 0, 0);
    mylcd.Print_String("Cycle number: " + String(Ncycle+1), 0, 18);
    
    pulses = NpulsesRevolutionZ*(length + extra_len)/pitch;
    Serial.print(length + extra_len);
    Serial.print("\t");
    Serial.print(pulses);
    Serial.print("\t");
    distanceCovered = 0.00;
    internVarZ = 0;
    halfperiodSpeed = 60*1000000;
    halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
    halfperiodSpeed = halfperiodSpeed/screwSpeed;
    periodSpeed = (int) halfperiodSpeed;
    Serial.print(halfperiodSpeed);
    Serial.print("\t");
    Serial.println(periodSpeed);

    digitalWrite(dirPin,HIGH);
    for(int i=0; i<pulses; i++) { // Makes 200 pulses for making one full cycle rotation
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(periodSpeed);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(periodSpeed);
      comebackVarZ++;
      internVarZ++;
      countZ++;
      if(countZ == NpulsesRevolutionZ){
        distanceCovered++;
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = 0;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
    distanceCovered = length + extra_len;
    distanceZ = positioning + distanceCovered;
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    mylcd.Print_String("Z-position: " + String(distanceCovered) + " mm", 0, 36);
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");
    Serial.print(comebackVarZ);
    Serial.print("\t");
    Serial.println(internVarZ);

    mylcd.Print_String("Return phase", 0, 72);
    mylcd.Print_String("Move back along X-axis", 0, 90);
    Serial.println(comebackVarX);
    delayMotor = 2;
    for(int i=0; i<internVarX; i++){ //move back as soon as the stage is completed
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Backward();
      comebackVarX--;
      countX--;
      if(countX == 0){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = NpulsesRevolutionX;
        lcd.setCursor(0,1);      
        lcd.print("X pos: " + String(distanceX)  + " mm");
      }
    }
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    lcd.setCursor(0,1);      
    lcd.print("X pos: " + String(distanceX)  + " mm");
    delay(500);

    mylcd.Print_String("Move back along Z-axis", 0, 108);
    Serial.println(comebackVarZ);
    digitalWrite(dirPin,LOW);
    for(int i=0; i<internVarZ; i++) {
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(halfT_screw);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(halfT_screw);
      comebackVarZ--;
      countZ--;
      if(countZ == 0){
        distanceCovered++;
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = NpulsesRevolutionZ;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");

    //re-positioning along the X-axis
    if((Ncycle+1) < numberCyclesCyl){
      mylcd.Print_String("Position along the X-axis of the feed:", 0, 144);
      internVarX = maxFeedX*NpulsesRevolutionX*(Ncycle+2);
      Serial.print(internVarX);
      Serial.print("\t");
      delayMotor = 2;
      for(int i=0; i<internVarX; i++){ //move forward as soon as the stage is completed
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);      
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      mylcd.Print_String("X-position: " + String(maxFeedX) + " mm", 0, 162);
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(comebackVarX);
      Serial.print("\t");
      Serial.println(internVarX);
      delay(1000);
    }
  }
  return comebackVarZ;
}

long conicalTurning(int screwSpeed){
  delay(500);  
  
  halfperiodSpeed = 60*1e6;
  halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
  halfperiodSpeed = halfperiodSpeed/screwSpeed;
  periodSpeed = (int) halfperiodSpeed;
  Serial.print(halfperiodSpeed);
  Serial.print("\t");
  Serial.println(periodSpeed);

  pulsesZconical = NpulsesRevolutionZ*deltaZ;
  pulsesXconical = NpulsesRevolutionX*deltaX;
  Serial.print(pulsesZconical);
  Serial.print("\t");
  Serial.print(pulsesXconical);
  Serial.print("\t");

  if(pulsesZconical >= pulsesXconical){ //more pulses for the motor Z than X
    partialPulses = pulsesZconical/pulsesXconical;
    residualPulses = pulsesZconical - pulsesXconical*partialPulses; //for the Z motor
    Serial.print(partialPulses);
    Serial.print("\t");
    Serial.println(residualPulses);

    for(int k=0; k<NcyclesConicalMax; k++){ //conical turning where the feed X is maximum
      mylcd.Fill_Screen(BLUE);
      mylcd.Print_String("Working roughing cycle:", 0, 0);
      mylcd.Print_String("Cycle number: " + String(k+1), 0, 18);
      //move the motor X according to the feed X
      mylcd.Print_String("Position along the X-axis of the feed:", 0, 36);
      internVarX = maxFeedX*NpulsesRevolutionX*(k + numberCyclesCyl + 1);
      Serial.print(internVarX);
      Serial.print("\t");
      delayMotor = 2;
      for(int i=0; i<internVarX; i++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);   
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      mylcd.Print_String("X-position: " + String(maxFeedX*(k + numberCyclesCyl + 1)) + " mm", 0, 54);
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(comebackVarX);
      Serial.print("\t");
      Serial.println(internVarX);
      delay(500);

      //move the motor Z along the extra-length
      pulsesExtra = NpulsesRevolutionZ*extra_len/pitch;
      Serial.print(pulsesExtra);
      Serial.print("\t");
      internVarZ = 0;
      digitalWrite(dirPin,HIGH);
      for(int j=0; j<pulsesExtra; j++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        digitalWrite(stepPin,HIGH);
        delayMicroseconds(halfT_screw);
        digitalWrite(stepPin,LOW); 
        delayMicroseconds(halfT_screw);
        comebackVarZ++;
        internVarZ++;
        countZ++;
        if(countZ == NpulsesRevolutionZ){
          distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
          countZ = 0;
          lcd.home();
          lcd.print("Z pos: " + String(distanceZ) + " mm");
        }
      }
      mylcd.Print_String("Z-position: " + String(extra_len) + " mm", 0, 72);
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
      Serial.print(comebackVarZ);
      Serial.print("\t");
      Serial.println(internVarZ);

      //move before the motor Z then perform the sequence of the motor X
      delayMotor = 2;
      digitalWrite(dirPin,HIGH);
      incr = 0; //at the end it must be equal to the pulsesX
      incrRes = 0; //the first residual pulses, the steps performed by the Z are increased by 1
      do{
        if(incrRes < residualPulses){
          n = partialPulses + 1; //number of pulses performed by the motor Z for the first residual steps
        }else{
          n = partialPulses;
        }
        for(int b=0; b<n; b++){
          startState = digitalRead(startPin);
          secCheckState = digitalRead(secCheckPin);
          if(startState == LOW || secCheckState == LOW){
            Emergency();
            ok = 2;
            return;
          }
          digitalWrite(stepPin,HIGH);
          delayMicroseconds(periodSpeed);
          digitalWrite(stepPin,LOW); 
          delayMicroseconds(periodSpeed);
          comebackVarZ++;
          internVarZ++;
          countZ++;
        }
        Backward();
        comebackVarX--;
        countX--;
        incr++;
        incrRes++;

        if(countZ == NpulsesRevolutionZ){
          distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
          countZ = 0;
          lcd.home();
          lcd.print("Z pos: " + String(distanceZ) + " mm");
        }

        if(countX == 0){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = NpulsesRevolutionX;
          lcd.setCursor(0,1);   
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
                  
        Serial.print(comebackVarZ);
        Serial.print("\t");
        Serial.println(internVarZ);

        Serial.println(comebackVarX);
        Serial.println(incr);
      }while(incr < pulsesXconical);
      mylcd.Print_String("Z-position: " + String(deltaZ+extra_len) + " mm", 0, 90);
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");

      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);   
      lcd.print("X pos: " + String(distanceX)  + " mm");

      //move back the tool
      mylcd.Print_String("Return phase", 0, 126);
      mylcd.Print_String("Move back along X-axis", 0, 144);
      if(internVarX <= pulsesXconical){
        delayMotor = 2;
        n = pulsesXconical - internVarX;
        for(int i=0; i<n; i++){
          startState = digitalRead(startPin);
          secCheckState = digitalRead(secCheckPin);
          if(startState == LOW || secCheckState == LOW){
            Emergency();
            ok = 2;
            return;
          }
          Forward();
          comebackVarX++;
          countX++;
          if(countX == NpulsesRevolutionX){
            distanceX = (float) comebackVarX/NpulsesRevolutionX;
            countX = 0;
            lcd.setCursor(0,1);   
            lcd.print("X pos: " + String(distanceX)  + " mm");
          }
        }
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        lcd.setCursor(0,1);   
        lcd.print("X pos: " + String(distanceX)  + " mm");
        Serial.print(pulsesXconical - internVarX);
        Serial.print("\t");
        Serial.println(comebackVarX);
      }else if(internVarX > pulsesXconical){
        delayMotor = 2;
        n = internVarX - pulsesXconical;
        for(int i=0; i<n; i++){
          startState = digitalRead(startPin);
          secCheckState = digitalRead(secCheckPin);
          if(startState == LOW || secCheckState == LOW){
            Emergency();
            ok = 2;
            return;
          }
          Backward();
          comebackVarX--;
          countX--;
          if(countX == 0){
            distanceX = (float) comebackVarX/NpulsesRevolutionX;
            countX = NpulsesRevolutionX;
            lcd.setCursor(0,1);   
            lcd.print("X pos: " + String(distanceX)  + " mm");
          }
        }
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        lcd.setCursor(0,1);   
        lcd.print("X pos: " + String(distanceX)  + " mm");
        Serial.print(internVarX - pulsesXconical);
        Serial.print("\t");
        Serial.println(comebackVarX);
      }
      delay(500);
    
      mylcd.Print_String("Move back along Z-axis", 0, 162);
      digitalWrite(dirPin,LOW);
      for(int i=0; i<internVarZ; i++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        digitalWrite(stepPin,HIGH);
        delayMicroseconds(halfT_screw);
        digitalWrite(stepPin,LOW); 
        delayMicroseconds(halfT_screw); 
        comebackVarZ--;
        countZ--;
        if(countZ == 0){
          distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
          countZ = NpulsesRevolutionZ;
          lcd.home();
          lcd.print("Z pos: " + String(distanceZ) + " mm");
        }
      }
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
      Serial.println(comebackVarZ);
      delay(500);
    }


    //last cycle where the feed X begin is not maximum
    if(residualFeedXbegin != 0){
      mylcd.Fill_Screen(BLUE);
      mylcd.Print_String("Working roughing cycle:", 0, 0);
      mylcd.Print_String("Cycle number: " + String(NcyclesConicalMax+1), 0, 18);
      //move the motor X according to the feed X
      mylcd.Print_String("Position along the X-axis of the feed:", 0, 36);
      internVarX = feedXbegin*NpulsesRevolutionX;
      Serial.print(internVarX);
      Serial.print("\t");
      delayMotor = 2;
      for(int i=0; i<internVarX; i++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);   
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      mylcd.Print_String("X-position: " + String(feedXbegin) + " mm", 0, 54);
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(comebackVarX);
      Serial.print("\t");
      Serial.println(internVarX);
      delay(500);

      //move the motor Z along the extra-length
      pulsesExtra = NpulsesRevolutionZ*extra_len/pitch;
      Serial.print(pulsesExtra);
      Serial.print("\t");
      internVarZ = 0;
      digitalWrite(dirPin,HIGH);
      for(int j=0; j<pulsesExtra; j++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        digitalWrite(stepPin,HIGH);
        delayMicroseconds(halfT_screw);
        digitalWrite(stepPin,LOW); 
        delayMicroseconds(halfT_screw);
        comebackVarZ++;
        internVarZ++;
        countZ++;
        if(countZ == NpulsesRevolutionZ){
          distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
          countZ = 0;
          lcd.home();
          lcd.print("Z pos: " + String(distanceZ) + " mm");
        }
      }
      mylcd.Print_String("Z-position: " + String(extra_len) + " mm", 0, 72);
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
      Serial.print(comebackVarZ);
      Serial.print("\t");
      Serial.println(internVarZ);

      //move before the motor Z then perform the sequence of the motor X
      delayMotor = 2;
      digitalWrite(dirPin,HIGH);
      incr = 0;
      incrRes = 0;
      do{
        if(incrRes < residualPulses){
          n = partialPulses + 1;
        }else{
          n = partialPulses;
        }
        for(int b=0; b<n; b++){
          startState = digitalRead(startPin);
          secCheckState = digitalRead(secCheckPin);
          if(startState == LOW || secCheckState == LOW){
            Emergency();
            ok = 2;
            return;
          }
          digitalWrite(stepPin,HIGH);
          delayMicroseconds(periodSpeed);
          digitalWrite(stepPin,LOW); 
          delayMicroseconds(periodSpeed);
          comebackVarZ++;
          internVarZ++;
          countZ++;
        }
        Backward();
        comebackVarX--;
        countX--;
        incr++;
        incrRes++;

        if(countZ == NpulsesRevolutionZ){
          distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
          countZ = 0;
          lcd.home();
          lcd.print("Z pos: " + String(distanceZ) + " mm");
        }

        if(countX == 0){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = NpulsesRevolutionX;
          lcd.setCursor(0,1);   
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }

        Serial.print(comebackVarZ);
        Serial.print("\t");
        Serial.println(internVarZ);
                
        Serial.println(comebackVarX);
        Serial.println(incr);
      }while(incr < pulsesXconical);
      mylcd.Print_String("Z-position: " + String(deltaZ+extra_len) + " mm", 0, 90);
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");

      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);   
      lcd.print("X pos: " + String(distanceX)  + " mm");

      //move back the tool
      mylcd.Print_String("Return phase", 0, 126);
      mylcd.Print_String("Move back along X-axis", 0, 144);
      if(internVarX <= pulsesXconical){
        delayMotor = 2;
        n = pulsesXconical - internVarX;
        for(int i=0; i<n; i++){
          startState = digitalRead(startPin);
          secCheckState = digitalRead(secCheckPin);
          if(startState == LOW || secCheckState == LOW){
            Emergency();
            ok = 2;
            return;
          }
          Forward();
          comebackVarX++;
          countX++;
          if(countX == NpulsesRevolutionX){
            distanceX = (float) comebackVarX/NpulsesRevolutionX;
            countX = 0;
            lcd.setCursor(0,1);   
            lcd.print("X pos: " + String(distanceX)  + " mm");
          }
        }
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        lcd.setCursor(0,1);   
        lcd.print("X pos: " + String(distanceX)  + " mm");
        Serial.print(pulsesXconical - internVarX);
        Serial.print("\t");
        Serial.println(comebackVarX);
      }else if(internVarX > pulsesXconical){
        delayMotor = 2;
        n = internVarX - pulsesXconical;
        for(int i=0; i<n; i++){
          startState = digitalRead(startPin);
          secCheckState = digitalRead(secCheckPin);
          if(startState == LOW || secCheckState == LOW){
            Emergency();
            ok = 2;
            return;
          }
          Backward();
          comebackVarX--;
          countX--;
          if(countX == 0){
            distanceX = (float) comebackVarX/NpulsesRevolutionX;
            countX = NpulsesRevolutionX;
            lcd.setCursor(0,1);   
            lcd.print("X pos: " + String(distanceX)  + " mm");
          }
        }
        Serial.print(internVarX - pulsesXconical);
        Serial.print("\t");
        Serial.println(comebackVarX);
      }
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);   
      lcd.print("X pos: " + String(distanceX)  + " mm");
    
      mylcd.Print_String("Move back along Z-axis", 0, 162);
      digitalWrite(dirPin,LOW);
      for(int i=0; i<internVarZ; i++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        digitalWrite(stepPin,HIGH);
        delayMicroseconds(halfT_screw);
        digitalWrite(stepPin,LOW); 
        delayMicroseconds(halfT_screw);
        comebackVarZ--; 
        countZ--;
        if(countZ == 0){
          distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
          countZ = NpulsesRevolutionZ;
          lcd.home();
          lcd.print("Z pos: " + String(distanceZ) + " mm");
        }
      }
      distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
      lcd.home();
      lcd.print("Z pos: " + String(distanceZ) + " mm");
      Serial.println(comebackVarZ);
      delay(500);
    }
  }
  return comebackVarZ;
}

long finishProcessConical(int screwSpeed){
  delay(500);

  halfperiodSpeed = 60*1000000;
  halfperiodSpeed = halfperiodSpeed/(2*NpulsesRevolutionZ);
  halfperiodSpeed = halfperiodSpeed/screwSpeed;
  periodSpeed = (int) halfperiodSpeed;
  Serial.print(halfperiodSpeed);
  Serial.print("\t");
  Serial.println(periodSpeed);

  pulsesZconical = NpulsesRevolutionZ*deltaZ;
  pulsesXconical = NpulsesRevolutionX*deltaX;
  Serial.print(pulsesZconical);
  Serial.print("\t");
  Serial.print(pulsesXconical);
  Serial.print("\t");

  if(pulsesZconical >= pulsesXconical){ //more pulses for the motor Z than X
    partialPulses = pulsesZconical/pulsesXconical;
    residualPulses = pulsesZconical - pulsesXconical*partialPulses; //for the Z motor
    
    Serial.print(partialPulses);
    Serial.print("\t");
    Serial.println(residualPulses);

    mylcd.Fill_Screen(BLUE);
    mylcd.Print_String("Working finishing cycle:", 0, 0);
    //move the motor X according to the feed X
    mylcd.Print_String("Position along the X-axis of the feed:", 0, 18);
    internVarX = (feedXbegin + feedXfinish)*NpulsesRevolutionX;
    Serial.print(internVarX);
    Serial.print("\t");
    delayMotor = 2;
    for(int i=0; i<internVarX; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      Forward();
      comebackVarX++;
      countX++;
      if(countX == NpulsesRevolutionX){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = 0;
        lcd.setCursor(0,1);   
        lcd.print("X pos: " + String(distanceX)  + " mm");
      }
    }
    mylcd.Print_String("X-position: " + String(feedXbegin + feedXfinish) + " mm", 0, 36);
    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    lcd.setCursor(0,1);
    lcd.print("X pos: " + String(distanceX)  + " mm");
    Serial.print(comebackVarX);
    Serial.print("\t");
    Serial.println(internVarX);
    delay(500);

    //move the motor Z along the extra-length
    pulsesExtra = NpulsesRevolutionZ*extra_len/pitch;
    Serial.print(pulsesExtra);
    Serial.print("\t");
    internVarZ = 0;
    digitalWrite(dirPin,HIGH);
    for(int j=0; j<pulsesExtra; j++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(halfT_screw);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(halfT_screw);
      comebackVarZ++;
      internVarZ++;
      countZ++;
      if(countZ == NpulsesRevolutionZ){
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = 0;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
    mylcd.Print_String("Z-position: " + String(extra_len) + " mm", 0, 54);
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");
    Serial.print(comebackVarZ);
    Serial.print("\t");
    Serial.println(internVarZ);
    
    //move before the motor Z then perform the sequence of the motor X
    delayMotor = 2;
    digitalWrite(dirPin,HIGH);
    incr = 0;
    incrRes = 0;
    do{
      if(incrRes < residualPulses){
        n = partialPulses + 1;
      }else{
        n = partialPulses;
      }
      for(int b=0; b<n; b++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        digitalWrite(stepPin,HIGH);
        delayMicroseconds(periodSpeed);
        digitalWrite(stepPin,LOW); 
        delayMicroseconds(periodSpeed);
        comebackVarZ++;
        internVarZ++;
        countZ++;
      }
      Backward();
      comebackVarX--;
      countX--;
      incr++;
      incrRes++;

      if(countZ == NpulsesRevolutionZ){
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = 0;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }

      if(countX == 0){
        distanceX = (float) comebackVarX/NpulsesRevolutionX;
        countX = NpulsesRevolutionX;
        lcd.setCursor(0,1);   
        lcd.print("X pos: " + String(distanceX)  + " mm");
      }

      Serial.print(comebackVarZ);
      Serial.print("\t");
      Serial.println(internVarZ);

      Serial.println(comebackVarX);
      Serial.println(incr);
    }while(incr < pulsesXconical);
    mylcd.Print_String("Z-position: " + String(deltaZ+extra_len) + " mm", 0, 72);
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");

    distanceX = (float) comebackVarX/NpulsesRevolutionX;
    lcd.setCursor(0,1);   
    lcd.print("X pos: " + String(distanceX)  + " mm");
  
    //move back the tool
    mylcd.Print_String("Return phase", 0, 108);
    mylcd.Print_String("Move back along X-axis", 0, 126);
    if(internVarX < pulsesXconical){
      delayMotor = 2;
      n = pulsesXconical - internVarX;
      for(int i=0; i<n; i++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Forward();
        comebackVarX++;
        countX++;
        if(countX == NpulsesRevolutionX){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = 0;
          lcd.setCursor(0,1);   
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);   
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(pulsesXconical - internVarX);
      Serial.print("\t");
      Serial.println(comebackVarX);
    }else if(internVarX >= pulsesXconical){
      delayMotor = 2;
      n = internVarX - pulsesXconical;
      for(int i=0; i<n; i++){
        startState = digitalRead(startPin);
        secCheckState = digitalRead(secCheckPin);
        if(startState == LOW || secCheckState == LOW){
          Emergency();
          ok = 2;
          return;
        }
        Backward();
        comebackVarX--;
        countX--;
        if(countX == 0){
          distanceX = (float) comebackVarX/NpulsesRevolutionX;
          countX = NpulsesRevolutionX;
          lcd.setCursor(0,1);   
          lcd.print("X pos: " + String(distanceX)  + " mm");
        }
      }
      distanceX = (float) comebackVarX/NpulsesRevolutionX;
      lcd.setCursor(0,1);   
      lcd.print("X pos: " + String(distanceX)  + " mm");
      Serial.print(internVarX - pulsesXconical);
      Serial.print("\t");
      Serial.println(comebackVarX);
    }
    
    mylcd.Print_String("Move back along Z-axis", 0, 144);
    Serial.println(comebackVarZ);
    digitalWrite(dirPin,LOW);
    for(int i=0; i<internVarZ; i++){
      startState = digitalRead(startPin);
      secCheckState = digitalRead(secCheckPin);
      if(startState == LOW || secCheckState == LOW){
        Emergency();
        ok = 2;
        return;
      }
      digitalWrite(stepPin,HIGH);
      delayMicroseconds(halfT_screw);
      digitalWrite(stepPin,LOW); 
      delayMicroseconds(halfT_screw);
      comebackVarZ--;
      countZ--;
      if(countZ == 0){
        distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
        countZ = NpulsesRevolutionZ;
        lcd.home();
        lcd.print("Z pos: " + String(distanceZ) + " mm");
      }
    }
    distanceZ = (float) comebackVarZ/NpulsesRevolutionZ;
    lcd.home();
    lcd.print("Z pos: " + String(distanceZ) + " mm");
    Serial.println(comebackVarZ);
    delay(500);
  }
  return comebackVarZ;
}