//for complete
float acquisitionWorkingLengthB(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical complete cycle", 0, 0);
  mylcd.Print_String("Insert the working length of the piece", 0, 18);
  mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
  mylcd.Print_String("Press '#' to confirm the value", 0, 54);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
  mylcd.Print_String("re-insert a new one", 0, 90);
  delay(300);

  workingLength = 0;
  checkWorkingLength = 0;
  workDistance = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        workDistance += inCharKey;
        mylcd.Print_String("Working length [mm]: " + workDistance, 0, 126);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        workDistance += '.';
        mylcd.Print_String("Working length [mm]: " + workDistance, 0, 126);
        delay(50);
      }else if(inCharKey == 'C'){
        workDistance = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical complete cycle", 0, 0);
        mylcd.Print_String("Insert the working length of the piece", 0, 18);
        mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
        mylcd.Print_String("Press '#' to confirm the value", 0, 54);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
        mylcd.Print_String("re-insert a new one", 0, 90);
        mylcd.Print_String("Working length [mm]: ", 0, 126);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        workingLength = workDistance.toFloat();
        if(workingLength > 0 && workingLength <= maxLength){
          mylcd.Print_String("Working length: ACCEPTED", 0, 144);
          delay(2000);
          checkWorkingLength = 1;
        }else{
          mylcd.Print_String("Working length not valid", 0, 144);
          mylcd.Print_String("Insert a new value", 0, 162);
          delay(1000);

          workingLength = 0;
          workDistance = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical complete cycle", 0, 0);
          mylcd.Print_String("Insert the working length of the piece", 0, 18);
          mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
          mylcd.Print_String("Press '#' to confirm the value", 0, 54);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
          mylcd.Print_String("re-insert a new one", 0, 90);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkWorkingLength == 0);
  Serial.println(workingLength);
  return workingLength;
}

//for multidiameter
float acquisitionWorkingLengthC(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
  mylcd.Print_String("Insert the working length of the piece", 0, 18);
  mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
  mylcd.Print_String("Press '#' to confirm the value", 0, 54);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
  mylcd.Print_String("re-insert a new one", 0, 90);
  delay(300);

  workingLength = 0;
  checkWorkingLength = 0;
  workDistance = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        workDistance += inCharKey;
        mylcd.Print_String("Working length [mm]: " + workDistance, 0, 126);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        workDistance += '.';
        mylcd.Print_String("Working length [mm]: " + workDistance, 0, 126);
        delay(50);
      }else if(inCharKey == 'C'){
        workDistance = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the working length of the piece", 0, 18);
        mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
        mylcd.Print_String("Press '#' to confirm the value", 0, 54);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
        mylcd.Print_String("re-insert a new one", 0, 90);
        mylcd.Print_String("Working length [mm]: ", 0, 126);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        workingLength = workDistance.toFloat();
        if(workingLength > 0 && workingLength <= maxLength){
          mylcd.Print_String("Working length: ACCEPTED", 0, 144);
          delay(2000);
          checkWorkingLength = 1;
        }else{
          mylcd.Print_String("Working length not valid", 0, 144);
          mylcd.Print_String("Insert a new value", 0, 162);
          delay(1000);

          workingLength = 0;
          workDistance = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the working length of the piece", 0, 18);
          mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
          mylcd.Print_String("Press '#' to confirm the value", 0, 54);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
          mylcd.Print_String("re-insert a new one", 0, 90);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkWorkingLength == 0);
  Serial.println(workingLength);
  return workingLength;
}

//for conical
float acquisitionWorkingLengthD(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Conical cycle", 0, 0);
  mylcd.Print_String("Insert the working length of the piece", 0, 18);
  mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
  mylcd.Print_String("Press '#' to confirm the value", 0, 54);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
  mylcd.Print_String("re-insert a new one", 0, 90);

  delay(300);

  workingLength = 0;
  checkWorkingLength = 0;
  workDistance = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        workDistance += inCharKey;
        mylcd.Print_String("Working length [mm]: " + workDistance, 0, 126);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        workDistance += '.';
        mylcd.Print_String("Working length [mm]: " + workDistance, 0, 126);
        delay(50);
      }else if(inCharKey == 'C'){
        workDistance = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Conical cycle", 0, 0);
        mylcd.Print_String("Insert the working length of the piece", 0, 18);
        mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
        mylcd.Print_String("Press '#' to confirm the value", 0, 54);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
        mylcd.Print_String("re-insert a new one", 0, 90);
        mylcd.Print_String("Working length [mm]: ", 0, 126);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        workingLength = workDistance.toFloat();
        if(workingLength > 0 && workingLength <= maxLength){
          mylcd.Print_String("Working length: ACCEPTED", 0, 144);
          delay(2000);
          checkWorkingLength = 1;
        }else{
          mylcd.Print_String("Working length not valid", 0, 144);
          mylcd.Print_String("Insert a new value", 0, 162);
          delay(1000);

          workingLength = 0;
          workDistance = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Conical cycle", 0, 0);
          mylcd.Print_String("Insert the working length of the piece", 0, 18);
          mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 36);
          mylcd.Print_String("Press '#' to confirm the value", 0, 54);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 72);
          mylcd.Print_String("re-insert a new one", 0, 90);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkWorkingLength == 0);
  Serial.println(workingLength);
  return workingLength;
}

//for multidiameter
float acquisitionWorkingLengthMultiSmaller(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0); //keep this instruction all along the process
  mylcd.Print_String("Insert the working length of the smaller", 0, 18);
  mylcd.Print_String("part of the piece with the keypad", 0, 36);
  mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);

  workingLength = 0;
  checkWorkingLength = 0;
  workDistance = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        workDistance += inCharKey;
        mylcd.Print_String("Smaller working length [mm]: " + workDistance, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        workDistance += '.';
        mylcd.Print_String("Smaller working length [mm]: " + workDistance, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        workDistance = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the working length of the smaller", 0, 18);
        mylcd.Print_String("part of the piece with the keypad", 0, 36);
        mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Smaller working length [mm]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        workingLength = workDistance.toFloat();
        Serial.println(workingLength);
        if(workingLength > 0 && workingLength <= maxLength){
          mylcd.Print_String("Smaller working length: ACCEPTED", 0, 162);
          delay(2000);
          checkWorkingLength = 1;
        }else{
          mylcd.Print_String("Working length not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          workingLength = 0;
          workDistance = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the working length of the smaller", 0, 18);
          mylcd.Print_String("part of the piece with the keypad", 0, 36);
          mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);   
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkWorkingLength == 0);
  return workingLength;
}

//for multidiameter
float acquisitionWorkingLengthMultiGreater(){
  mylcd.Fill_Screen(BLUE);
  mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0); //keep this instruction all along the process
  mylcd.Print_String("Insert the working length of the greater", 0, 18);
  mylcd.Print_String("part of the piece with the keypad", 0, 36);
  mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 54);
  mylcd.Print_String("Press '#' to confirm the value", 0, 72);
  mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
  mylcd.Print_String("re-insert a new one", 0, 108);

  workingLength = 0;
  checkWorkingLength = 0;
  workDistance = "";

  do{
    delay(50);
    char inCharKey = customKeypad.getKey();
    startState = digitalRead(startPin);
    secCheckState = digitalRead(secCheckPin);

    if(inCharKey && startState == HIGH && secCheckState == LOW){
      if(inCharKey != 'A' && inCharKey != 'B' && inCharKey != 'C' && inCharKey != 'D' && inCharKey != '*' && inCharKey != '#'){ //a number has been inserted
        workDistance += inCharKey;
        mylcd.Print_String("Greater working length [mm]: " + workDistance, 0, 144);
        delay(50);
      }else if(inCharKey == '*'){ //'*' = '.'
        workDistance += '.';
        mylcd.Print_String("Greater working length [mm]: " + workDistance, 0, 144);
        delay(50);
      }else if(inCharKey == 'C'){
        workDistance = "";
        mylcd.Fill_Screen(BLUE);
        mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
        mylcd.Print_String("Insert the working length of the greater", 0, 18);
        mylcd.Print_String("part of the piece with the keypad", 0, 36);
        mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 54);
        mylcd.Print_String("Press '#' to confirm the value", 0, 72);
        mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
        mylcd.Print_String("re-insert a new one", 0, 108);
        mylcd.Print_String("Greater working length [mm]: ", 0, 144);
        delay(50);
      }else if(inCharKey == '#'){ //all the digits of the diameter and the ok digit have been inserted
        workingLength = workDistance.toFloat();
        Serial.println(workingLength);
        if(workingLength > 0 && workingLength <= maxLength){
          mylcd.Print_String("Greater working length: ACCEPTED", 0, 162);
          delay(2000);
          checkWorkingLength = 1;
        }else{
          mylcd.Print_String("Working length not valid", 0, 162);
          mylcd.Print_String("Insert a new value", 0, 180);
          delay(1000);

          workingLength = 0;
          workDistance = "";
          mylcd.Fill_Screen(BLUE);
          mylcd.Print_String("Cylindrical multidiameter cycle", 0, 0);
          mylcd.Print_String("Insert the working length of the greater", 0, 18);
          mylcd.Print_String("part of the piece with the keypad", 0, 36);
          mylcd.Print_String("with the keypad 0 mm and 200 mm", 0, 54);
          mylcd.Print_String("Press '#' to confirm the value", 0, 72);
          mylcd.Print_String("Press 'C' to delete the value and", 0, 90);
          mylcd.Print_String("re-insert a new one", 0, 108);
        }
      }
    }else if(startState == LOW || secCheckState == HIGH){
      Emergency();
      ok = 2;
      return; 
    }
  }while(checkWorkingLength == 0);
  return workingLength;
}